/****************************************************************************
* Aplicativo : SMTGeR... Servidor de Microterminais Gertec - Restaurante    *
* Autor		 : Ana Lcia S. Melo 										    *
* Referncia : SMTGeR - Programa Servidor para Micro Terminais              *
* Data       : 07/07/08													    *
* Ambiente   : Visual C++ 2005 (Express Edition)                            *
* Fonte      : structres.h													*
* Objetivo   : Exemplificar a declarao da estrutura necessarias para o	*
*			   programa, onde sero armazenadas as informaes recebidas   	*
* Notas		 : Este fonte destina-se exclusivamente como material de	    *
*			   auxilio a desenvolvedores de aplicaes para produtos Gertec.*
****************************************************************************/

#ifndef STRUCTRES_H
#define STRUCTRES_H

#pragma pack(push)
#pragma pack(1)

typedef struct{
    unsigned int codCartao;
    char StatusCartao[1];
    unsigned int txServico;
	unsigned int txConsumacao;
}Cartao;

typedef struct{
    unsigned int CodProduto;
    char DescricaoProduto[40];
    float Valor;
    char Obs[1024];
    float Quantidade;
    unsigned int ValorTotal;
    char Observ[1024];
} Produto;

typedef struct{ 
	unsigned int CodGuia;
    char NomeGuia[50];
} Guia;

typedef struct{
    unsigned int CodUsuario;
    char Usuario[50];
    unsigned char Senha;
    unsigned int FuncaoID;
    Cartao Card;
    char Local[10];
    Guia Guia;
    float TotalCartao;
    unsigned int TotalProdutos;
    Produto Cesta[128];
    unsigned int imheID;
} PedidoType;


#pragma pack(pop)

#endif /*STRUCTRES_H*/