unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Winsock, Menus, ComCtrls, Tabnotbk, Db, DBTables,
  OleServer, ShellApi;

// DECLARAO DE TIPOS, COMPONENTES, PROCEDURES E FUNES GERAIS

type TTABSOCK = packed record
    TSOCK: array [0..255] of DWORD;
end;

type TSetupTCP = packed record
    microT_IP: DWORD; // Endereo IP do terminal
    server_IP: DWORD; // Endereo IP do servidor
    msknet_IP: DWORD; // Mscara de rede
    bDHCP: DWORD; // 1 = IP dinmico, 0 = IP fixo
end;

type TSetupSerial = packed record
    baud: DWORD; // Baud Rate: 1200 a 115.200
    bits: WORD; // Data Bits
    parity: WORD; // Paridade
    stops: WORD; // Stop Bits
    handshaking: BYTE; // 0 = Sem Hand Shaking, 1 = RTS/CTS
end;

type ARG_COM_SETUPSERIAL = packed record
    com: BYTE;
    Setup: TSetupSerial;
end;

Type Cartao = packed record
    codCartao: Integer;
    StatusCartao: String;
    txServico: Integer;
    txConsumacao: Integer;

End;
Type Produto = packed record
    CodProduto: Integer;
    DescricaoProduto: String;
    Valor: Real ;
    Obs: String;
    Quantidade: Real;
    ValorTotal: Integer ;
    Observ: String;
End;

Type Guia = packed record
   CodGuia: Integer;
   NomeGuia: String;

End;
Type PedidoType = packed record

    CodUsuario: Integer;
    Usuario: String;
    Senha: String;
    FuncaoID: Integer;
    Card: Cartao;
    Local: String;
    Guia: Guia;
    TotalCartao: Real;
    TotalProdutos: integer;
    Cesta: array [1..128] of Produto;
    imheID: Integer;

end;

type
  TFrmPrincipal = class(TForm)
    Timer1: TTimer;
    TabbedNotebook1: TTabbedNotebook;
    GroupBox1: TGroupBox;
    ListBox2: TListBox;
    GroupBox2: TGroupBox;
    ListBox1: TListBox;
    GroupBox7: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    cbPorta: TComboBox;
    cbBaud: TComboBox;
    cbBits: TComboBox;
    cbParidade: TComboBox;
    cbStop: TComboBox;
    cbHand: TComboBox;
    btnEnviarConfSerial: TButton;
    btnRecebeConfSerial: TButton;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    Label5: TLabel;
    txComanPeso: TEdit;
    Label6: TLabel;
    txComBalanca: TEdit;
    Label13: TLabel;
    txDigPeso: TEdit;
    txRecPeso: TEdit;
    txPosPeso: TEdit;
    ckReqPeso: TCheckBox;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    txComImp: TEdit;
    OpImp: TCheckBox;
    Label17: TLabel;
    btImprimi: TButton;
    btAtualiza: TButton;
    cbAlias: TComboBox;
    MainMenu1: TMainMenu;
    btIniciar: TMenuItem;
    ConfiguraodoBanco1: TMenuItem;
    bSair: TMenuItem;
    ConfBD: TMenuItem;
    Label1: TLabel;
    qrProd: TQuery;
    LbProd: TListBox;
    Button1: TButton;
    ListBox3: TListBox;

    procedure WndProc(var Message : TMessage); override;
    procedure Timer1Timer(Sender: TObject);
    procedure btnEnviarConfSerialClick(Sender: TObject);
    procedure btnRecebeConfSerialClick(Sender: TObject);
    procedure btAtualizaClick(Sender: TObject);
    procedure btImprimiClick(Sender: TObject);
    procedure btIniciarClick(Sender: TObject);
    procedure ConfBDClick(Sender: TObject);
    procedure bSairClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cbAliasChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);


  private
    { Private declarations }
  public
    { Public declarations }
     procedure TimerPasso(qconec: integer);
     public Pedido: array [1..32] of PedidoType;
     public PedidoG: array [0..255] of PedidoType;



  end;

//  VARIVEIS

Const IDvLive = 2;

Const IDvGetSetupTCP = 8;

Const IDvBackSpace = 34;
Const IDvCarRet = 36;
Const IDvLineFeed = 38;
Const IDvFormFeed = 40;
Const IDvGoToXY = 42;
Const IDvGoToXYRef = 44;
Const IDvDispStr = 52;
Const IDvDispCh = 54;
Const IDvDispClrLn = 56;
Const IDvSetEditString = 48;
Const IDbGetEditString = 50;
Const IDbReadEditString = 45;

Const IDcGetCharTerm = 29;
Const IDvSetEnableKey = 16;
Const IDbGetEnableKey = 18;
Const IDvSetCapsLock = 22;
Const IDbGetCapsLock = 24;
Const IDvSetNumLock = 26;
Const IDbGetNumLock = 28;
Const IDvReset = 20;

Const IDvSetEnableSerial = 58;
Const IDbGetEnableSerial = 60;
Const IDbSetSetupSerial = 66;
Const IDvGetSetupSerial = 68;
Const IDbGetBinSerial = 61;
var
  FrmPrincipal: TFrmPrincipal;
  MsgReceiveData: LONGINT;


implementation

uses cls_ComandosBanco;

var

  tabcon: TTABSOCK;
  auxIP: TINADDR;
  id_IP: TINADDR;
  retorno_IP: String;
  palavra: array [1..256] of String;
  passo: array [0..255] of  integer;
  NumeroProd:array [0..255] of Integer;
  sendcod: array [0..255] of byte;
  peso:array [1..32] of  boolean;



{$R *.DFM}

//  DECLARAO DE FUNES E ROTINAS

// INICIALIZAO E FINALIZAO
function mt_startserver(mywhnd: HWND; conecmsg: DWORD; commumsg: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
procedure mt_finishserver; far; stdcall; external 'pmtg.dll';
function mt_connectlist: TTABSOCK; far; stdcall; external 'pmtg.dll';

// FUNES DE TRATAMENTO DE IP
function mt_inet_ntoa_inv(oip: DWORD): PChar; far; stdcall; external 'pmtg.dll';
function mt_inet_addr_inv(oip: String): DWORD; far; stdcall; external 'pmtg.dll';

// COMANDOS BSICOS PARA O TERMINAL
function mt_sendlive(id: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_restart(id: DWORD): DWORD; far; stdcall; external 'pmtg.dll';

// REDE
function mt_sendconfig(id: DWORD; var config: TSetupTCP): DWORD; far; stdcall; external 'pmtg.dll';
function mt_reqconfig(id: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_getconfig(id: DWORD; var config: TSetupTCP): DWORD; far; stdcall; external 'pmtg.dll';

// DISPLAY
function mt_backspace(id: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_carret(id: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_linefeed(id: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_formfeed(id: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_gotoxy(id: DWORD; lin: DWORD; col: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_dispstr(id: DWORD; var str: BYTE): DWORD; far; stdcall; external 'pmtg.dll';
function mt_dispch(id: DWORD; ch: BYTE): DWORD; far; stdcall; external 'pmtg.dll';
function mt_seteditstring(id: DWORD; var str: BYTE; OnOff: DWORD; PassWord: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_geteditstring(id: DWORD; var str: BYTE): DWORD; far; stdcall; external 'pmtg.dll';
function mt_reqeditstring(id: DWORD): DWORD; far; stdcall; external 'pmtg.dll';

// TECLADO
function mt_setenablekey(id: DWORD; OnOff: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_getenablekey(id: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_reset(id: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_getkey(id: DWORD; var buf: BYTE): DWORD; far; stdcall; external 'pmtg.dll';


// SERIAL
function mt_setenableserial(id: DWORD; COM: BYTE; OnOff: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_getenableserial(id: DWORD; COM: BYTE): DWORD; far; stdcall; external 'pmtg.dll';
function mt_sendbinserial(id: DWORD; COM: BYTE; var bin: BYTE; tam: BYTE): DWORD; far; stdcall; external 'pmtg.dll';
function mt_sendconfigserial(id: DWORD; var config: ARG_COM_SETUPSERIAL): DWORD; far; stdcall; external 'pmtg.dll';
function mt_reqconfigserial(id: DWORD; COM: BYTE): DWORD; far; stdcall; external 'pmtg.dll';
function mt_getconfigserial(id: DWORD; var config: ARG_COM_SETUPSERIAL): DWORD; far; stdcall; external 'pmtg.dll';
function mt_getserial(id: DWORD; var sercom: DWORD; var buf: array of BYTE): DWORD; far; stdcall; external 'pmtg.dll';


// AUXILIAR

//********************************************************************************************************
// Funo: retorna_IP
//********************************************************************************************************
//
// Data de Criao: 13/05/2008
//
// Descrio: Transforma o ID de um terminal em um endereo IP
//
//********************************************************************************************************

function retorna_IP(id: DWORD): String;
begin
    // Recebe ID dos terminais conectados e armazena no vetor.
    tabcon := mt_connectlist;
    // Transforma o ID em um endereo vlido.
    id_IP.S_addr := tabcon.TSOCK[id];
    // Formata para um endereo de IP pontuado.
    retorna_IP := (inet_ntoa(id_IP));
end;


//********************************************************************************************************
// Evento: WndProc
//********************************************************************************************************
//
// Data de Criao: 13/05/2008
//
// Entrada: TMessage
//
// Sada: Void
//
// Descrio: Recebe mensagens enviadas pelo terminal e as compara com as constantes referentes a cada
//            comando
//
//********************************************************************************************************

procedure TFrmPrincipal.WndProc(var Message : TMessage);
label continua;
var buf: array [0..255] of BYTE;
    bufbalanc: array [0..255] of BYTE;

    print:array [0..255] of string;
    strbuf: string ;
    configserial: ARG_COM_SETUPSERIAL;
    str: String;
    porta: DWORD;
    tam: byte;
    cont: byte;
    msg: array [1..256] of byte;
    strUser: string;
    a: byte;
    i: integer;
    j: integer;
    k: integer;
    l: integer;
    coman: integer;
    price: Real;
    isnumber: integer;
    intcase: boolean;

    posicao: integer;

begin

   if (Message.Msg = MsgReceiveData) then begin
      //Zera o Buf para armazenamento dos caracteres recebidos
      isnumber:= 0;
      l:= 0;
      coman:= 0;
      price:=0;
      For cont := 0 to 255 do buf[cont]:= 0;

//*************************************************************************************
       // IDbGetBinSerial - Verifica foi recebido alguma informao pela serial.
//*************************************************************************************
      if (Message.WParam = IDbGetBinSerial) then
      begin
         porta:= StrToInt (txComBalanca.Text) - 1;
         If mt_getserial(Message.LParamLo, porta,  bufbalanc[0])> 0 Then
          If (passo[Message.LParamLo]= 6) And ((ckReqPeso.Checked = true) or (sendcod[0] = 5)) Then
            if (sendcod[0] = 5) and (peso[Message.LParamLo] = true) then begin
               // Rotina de incluso do peso no display
               //Verifica se  numerico
               for k:=0 to 255 do begin
                  isnumber:= 0;
                  str:= char(bufbalanc[k]);

                  for j:= 0 to 9 do begin
                     if str = IntToStr(isnumber)then begin
                        //Inclui virgula
                        If (StrToInt(txdigPeso.Text)- coman = 3) Then begin
                           strbuf:= strbuf + (',');
                           coman := coman + 1;
                        end Else coman := coman + 1;
                        strbuf:= strbuf + str;
                        break;
                     end else isnumber:= isnumber + 1;
                  end;
               end;
               StrPcopy (@Msg, strbuf);

               for i:=1 to Length(strbuf) do mt_dispch (message.LParamLo, msg[i]);

               palavra[message.LParamLo] := strbuf;


            end else
            If (StrToInt(txRecPeso.Text) =(bufbalanc[0])) Then Begin
               peso[Message.LParamLo] := True; //Informa que o produto pesado neste momento  prioridade e desabilita a digitao
               palavra[Message.LParamLo] := ''; // Limpa o buffer para no incluir algo que foi digitado anteriormente
               mt_gotoxy(Message.LParamLo, 2, 10); //posiciona o cursor

               // Rotina de troca de informao - QTD por PESO
               StrPcopy (@Msg,'Peso:      ');
               mt_dispstr (Message.lParamLo, Msg[1]);
               mt_gotoxy(Message.LParamLo, 2, 15);
               posicao := StrToInt(txPosPeso.Text) + (strToInt(txDigPeso.Text));

               // Rotina de incluso do peso no display
               For i := StrToInt(txPosPeso.Text) To posicao -1  do begin
                  isnumber:= 0;
                  str:= char(bufbalanc[i]);

                  for j:= 0 to 9 do begin
                     if str = IntToStr(isnumber)then begin
                        //Inclui virgula
                        If (StrToInt(txdigPeso.Text)- coman = 3) Then begin
                           strbuf:= strbuf + (',');
                           coman := coman + 1;
                        end Else coman := coman + 1;
                        strbuf:= strbuf + str;
                        break;
                     end else isnumber:= isnumber + 1;
                  end;
               End;
               StrPcopy (@Msg, strbuf);

               for i:=1 to Length(strbuf) do mt_dispch (message.LParamLo, msg[i]);
               palavra[message.LParamLo] := strbuf;

            End;
      End;

//*************************************************************************************
       // IDcGetCharTerm - Verifica as teclas digitadas filtrando as necessrias.
//*************************************************************************************
       if (Message.WParam = IDcGetCharTerm) then
       begin
          // Recebe uma tecla do terminal
          mt_getkey(Message.LParamLo, buf[0]);
          strbuf:= PChar(@buf[0]);
          if (peso[Message.LParamLo] = false) then begin
             for i:= 0 to 9 do begin
                if strbuf = IntToStr(isnumber)then begin
                   intcase := true;
                   break;
                end else intcase := False;
                 isnumber:= isnumber + 1;
             end;
          end;
         // Se a tecla for numerica envia ao display do microterminal
         if intcase = true then begin
            mt_dispch(Message.LParamLo,buf[0]);
            sleep (100);
            palavra[Message.LParamLo] := palavra[Message.LParamLo] + strbuf;
         end else begin
            //Caso tenha apertado a tecla "+" verifica se esta no passo 6 (incluso da qtd do produto)
            // e efetua o peso do produto atraves da balana conectada em determinada porta.
            if (passo[Message.LParamLo] = 6 )and (buf[0]= 43) then begin
               peso[Message.LParamLo]:= true;  //Prioriza pesagem ao inves de digitao
               palavra[Message.LParamLo]:='';

               //Verifica a porta Com
               if txComBalanca.text = '' then porta:= 0
               else porta:= StrToInt (txComBalanca.Text)-1;

               //Verifica o comando de envio para receber o peso da balana
               if txComanPeso.Text = '' then  sendcod[0]:= 05
               else sendcod[0]:= StrToInt(txComanPeso.Text);
               mt_gotoxy(Message.LParamLo, 2, 10); //posiciona o cursor
               // Rotina de troca de informao - QTD por PESO
               StrPcopy (@Msg,'Peso:      ');
               mt_dispstr (Message.lParamLo, Msg[1]);
               mt_gotoxy(Message.LParamLo, 2, 15);

               mt_setenableserial (Message.LParamLo, porta, 1);
            //   posicao := StrToInt(txPosPeso.Text) + (strToInt(txDigPeso.Text));
               sleep(50);

               // Envia o comando para recebimento do peso
              if (mt_sendbinserial(Message.LParamLo, porta, sendcod[0], 1) < 1)then
                 ShowMessage ('erro serial');
              Sleep(450); // Tempo de espera para atualizao da balana
              palavra[message.LParamLo]:= '';

            end else
            //Caso no seja uma tecla numrica verifica se foi pressionado
            //a tecla Backspace, Enter ou ESC
            if (buf[0] = 8 )or ((buf[0] = 13) or (buf[0] = 27 ))then begin
              {************************************************************
               *   Se a tecla foi Backspace segue o seguinte procedimento *
               ************************************************************}
               if buf[0] = 8 then begin
                  if (palavra [Message.LParamLo] <> '') and (peso[message.LParamLo] = false) then begin
                     mt_backspace (Message.LParamLo);
                     palavra[Message.LParamLo] := Copy (palavra[Message.LParamLo], 1, Length(palavra[Message.LParamLo])-1);
                  end;
              {***********************************************************
               *   Se a tecla foi ENTER segue o seguinte procedimento    *
               ***********************************************************}
               end else if (buf[0]= 13) then begin
                  peso[message.LParamLo]:= false;
                  sendcod[0]:= 0;
                  case passo[Message.LParamLo] of
                     0:
                     begin
                        passo[Message.LParamLo] := 1;
                        TimerPasso(Message.LParamLo) ;
                        palavra[Message.LParamLo] := '';
                     end;
                     {****OPERADOR****}
                     1: begin
                        if palavra[Message.LParamLo] = '' then begin
                           TimerPasso (Message.LParamLo);
                           palavra[Message.LParamLo]:= '';
                        end else
                        //Consulta o codigo do operador
                        if cls_ComandosBanco.LancamentoUsuario (palavra[Message.LParamLo], Message.LParamLo)= True then begin
                           passo[Message.LParamLo]:= passo[Message.LParamLo] + 1;
                           TimerPasso(Message.LParamLo);
                           palavra[Message.LParamLo]:= '';
                        end else begin
                           //Caso no tenha um operador envia OPERADOR iNVALIDO!!!
                           mt_formfeed (Message.LParamLo);
                           StrPcopy (@Msg,'    OPERADOR');
                           mt_dispstr (Message.lParamLo, Msg[1]);

                           mt_linefeed (Message.LParamLo);
                           mt_carret (Message.LParamLo);
                           StrPcopy (@Msg,'   INVALIDO!!!');
                           mt_dispstr( Message.LParamLo, Msg[1]);
                           Sleep (100);
                           TimerPasso(Message.LParamLo);
                           palavra[Message.LParamLo]:= '';
                        end;
                     end;
                     {***CARTAO***}
                     2: begin
                        if palavra[Message.LParamLo] = '' then begin
                           TimerPasso (Message.LParamLo);
                           palavra[Message.LParamLo]:= '';
                        end else
                        //Consulta o codigo do operador
                        if cls_ComandosBanco.LancamentoCartao (palavra[Message.LParamLo], Message.LParamLo)= True then begin
                           NumeroProd[Message.LParamLo] := 1;
                           passo[Message.LParamLo]:= passo[Message.LParamLo] + 1;
                           TimerPasso(Message.LParamLo);
                           palavra[Message.LParamLo]:= '';
                        end else begin
                           //Caso no tenha um carto vlido envia CARTAO INVALIDO!!!
                           mt_formfeed (Message.LParamLo);
                           StrPcopy (@Msg,'     CARTAO');
                           mt_dispstr (Message.LParamLo, Msg[1]);
                           mt_linefeed (Message.LParamLo);
                           mt_carret (Message.LParamLo);
                           StrPcopy (@Msg,'   INVALIDO!!!');
                           mt_dispstr( Message.LParamLo, Msg[1]);
                           sleep (100);
                           TimerPasso(Message.LParamLo);
                           palavra[Message.LParamLo]:= '';
                        end;
                     end;
                     {***LOCAL***}
                     3: begin
                        If palavra[Message.LParamLo] = '' Then begin
                           passo[Message.LParamLo] := passo[Message.LParamLo] + 1;
                           TimerPasso (Message.LParamLo);
                           PedidoG[Message.LParamLo].Local := '0';
                           palavra[Message.LParamLo] := '';
                        end else begin
                           passo[Message.LParamLo] := passo[Message.LParamLo] + 1;
                           TimerPasso(Message.LParamLo);
                           PedidoG[Message.LParamLo].Local := palavra[Message.LParamLo];
                           palavra[Message.LParamLo] := '';
                        end;
                     end;
                     {***GUIA***}
                     4:begin
                        If palavra[Message.LParamLo] = '' Then Begin
                           passo[Message.LParamLo] := passo[Message.LParamLo] + 1;
                           TimerPasso(message.LParamLo);
                           PedidoG[Message.LParamLo].Guia.CodGuia := 0;
                           PedidoG[Message.LParamLo].Guia.NomeGuia := '';
                        end else
                        If cls_ComandosBanco.LancamentoGuia(palavra[Message.LParamLo], Message.LParamLo) = True Then Begin
                           passo[Message.LParamLo] := passo[Message.LParamLo] + 1;
                           TimerPasso (message.LParamLo);
                           palavra[Message.LParamLo] := '';
                        end else begin
                           //Caso no tenha uma guia valida envia GUIA INVALIDA!!!
                           mt_formfeed (Message.LParamLo);
                           StrPcopy (@Msg,'     GUIA');
                           mt_dispstr (Message.LParamLo, Msg[1]);

                           mt_linefeed (Message.LParamLo);
                           mt_carret (Message.LParamLo);
                           StrPcopy (@Msg,'   INVALIDA!!!');
                           mt_dispstr( Message.LParamLo, Msg[1]);

                           sleep (100);
                           TimerPasso(Message.LParamLo);
                           palavra[Message.LParamLo]:= '';
                        end;
                     end;
                     {***PRODUTOS***}
                     5: begin
                        if palavra[Message.LParamLo] = '' then begin
                           j := 0;
                           //Finalizao dos pedidos...
                           // Se houver pedidos estes so inclusos na lista e finalizado.
                           if Numeroprod[Message.LParamLo] <>1 THEN BEGIN
                              print[j]:= '****** Sistema de Restaurante Gertec ******';
                              j:= j + 1;
                              print[j]:= 'Data: '+ DateToStr(date)+ '    Horario: '+ TimeToStr(Time);
                              ListBox2.Items.Add (print[J]);
                              j:= j + 1;
                              //Inclui o pedido na lista e no buffer de impressao (print[])
                              ListBox2.Items.Add (IntToStr(PedidoG[Message.LParamLo].codUsuario) + ' - ' + PedidoG[Message.LParamLo].Usuario);
                              print[j]:= (IntToStr(PedidoG[Message.LParamLo].codUsuario) + ' - ' + PedidoG[Message.LParamLo].Usuario);
                              j := j + 1;
                              ListBox2.Items.Add ('Cartao - ' + IntToStr(PedidoG[Message.LParamLo].Card.codCartao));
                              print[j]:= ('Cartao - ' + IntToStr(PedidoG[Message.LParamLo].Card.codCartao));
                              j := j + 1;
                              ListBox2.Items.Add ('Local - ' + (PedidoG[Message.LParamLo].Local));
                              print[j]:= ('Local - ' + (PedidoG[Message.LParamLo].Local));
                              j := j + 1;
                              ListBox2.Items.Add ('Guia - ' + IntToStr(PedidoG[Message.LParamLo].Guia.CodGuia) + ' - ' + PedidoG[Message.LParamLo].Guia.NomeGuia);
                              print[j]:= ('Guia - ' + IntToStr(PedidoG[Message.LParamLo].Guia.CodGuia) + ' - ' + PedidoG[Message.LParamLo].Guia.NomeGuia);
                              j := j + 1;

                              For i := 1 To NumeroProd[Message.LParamLo] - 1 do begin
                                 ListBox2.Items.Add (IntToStr(PedidoG[Message.LParamLo].Cesta[i].CodProduto) + ' - ' + PedidoG[Message.LParamLo].Cesta[i].DescricaoProduto + ' x ' + FloatToStr(PedidoG[Message.LParamLo].Cesta[i].Quantidade));
                                 print[j]:= (IntToStr(PedidoG[Message.LParamLo].Cesta[i].CodProduto) + ' - ' + PedidoG[Message.LParamLo].Cesta[i].DescricaoProduto + ' x ' + FloatToStr(PedidoG[Message.LParamLo].Cesta[i].Quantidade));
                                 j := j + 1;
                                 ListBox2.Items.Add ('Valor Unit: ' + FormatCurr('#.00', (PedidoG[Message.LParamLo].Cesta[i].Valor)) + ' .......Total: ' + FormatCurr('#.00',(PedidoG[Message.LParamLo].Cesta[i].Valor * PedidoG[Message.LParamLo].Cesta[i].Quantidade)));
                                 print[j]:= ('Valor Unit: ' + FormatCurr('#.00', (PedidoG[Message.LParamLo].Cesta[i].Valor)) + ' .......Total: ' + FormatCurr('#.00',(PedidoG[Message.LParamLo].Cesta[i].Valor * PedidoG[Message.LParamLo].Cesta[i].Quantidade)));
                                 j := j + 1;
                                 If Length(PedidoG[Message.LParamLo].Cesta[i].Obs) > 0 Then begin
                                    ListBox2.Items.Add ('      (' + PedidoG[Message.LParamLo].Cesta[i].Obs + ')');
                                    print[j]:= ('      (' + PedidoG[Message.LParamLo].Cesta[i].Obs + ')');
                                    j := j + 1;
                                    PedidoG[Message.LParamLo].Cesta[i].Obs := '';
                                 End;
                                 // Verifica o total dos pedidos
                                 PedidoG[Message.LParamLo].TotalCartao := PedidoG[Message.LParamLo].TotalCartao + PedidoG[Message.LParamLo].Cesta[i].Valor * PedidoG[Message.LParamLo].Cesta[i].Quantidade;
                                 price := (PedidoG[Message.LParamLo].Cesta[i].Valor * PedidoG[Message.LParamLo].Cesta[i].Quantidade) + price;
                              end;

                              ListBox2.Items.Add ('Total: ' + FormatCurr('#.00', price)) ;
                              print[j]:= ('Total: ' + FormatCurr('#.00',price)) ;
                              j := j + 1;
                              ListBox2.Items.Add (' - - - - - - - - - - - - - - - - - - - - - - - - - ');
                              print[j]:= (' - - - - - - - - - - - - - - - - - - - - - - - - ');


                              //Efetua a gravao do carto
                              if (cls_ComandosBanco.LancamentoGravarDados(IntToStr(PedidoG[Message.LParamLo].Card.codCartao)) = True) then Begin
                                 mt_formfeed (Message.LParamLo);
                                 StrPcopy (@Msg,'   LANCAMENTO');
                                 mt_dispstr (Message.LParamLo, Msg[1]);

                                 mt_linefeed (Message.LParamLo);
                                 mt_carret (Message.LParamLo);
                                 StrPcopy (@Msg,'   EFETUADO!!!');
                                 mt_dispstr( Message.LParamLo, Msg[1]);

                                 sleep (100);

                                 passo[Message.LParamLo] := 2;     //volta para Carto:
                                 TimerPasso(Message.LParamLo);
                                 palavra[Message.LParamLo]:= '';

                              end else begin
                                 mt_formfeed (Message.LParamLo);
                                 StrPcopy (@Msg,'   LANCAMENTO');
                                 mt_dispstr (Message.LParamLo, Msg[1]);

                                 mt_linefeed (Message.LParamLo);
                                 mt_carret (Message.LParamLo);
                                 StrPcopy (@Msg,' SEM GRAVACAO!!!');
                                 mt_dispstr( Message.LParamLo, Msg[1]);

                                 sleep (100);

                                 passo[Message.LParamLo] := 2;     //volta para Carto:
                                 TimerPasso(Message.LParamLo);
                                 palavra[Message.LParamLo]:= '';
                              end;
                             {********************************************************
                              *                 ROTINA PARA IMPRESSO                *
                              ********************************************************}
                              if OpImp.Checked = true then begin  //Se o boto imprimir estiver ativo segue a rotina
                                 if txComImp.Text= '' then porta:= 0  //Verifica a porta indiada a impressora
                                 else porta:= StrToInt(txComImp.Text) - 1;
                                 mt_setenableserial (message.LParamLo, porta, 10);//Habilita a serial
                                 for i:=0 to j do begin
                                    if Length (print[i])> 256 then //Se tiver mais de 256 caracteres a string deve ser dividida
                                    continua: begin                //pois acima de 256 ir travar
                                       For k := 0 To 255 do buf[k]:=0;  //Zera o vetor Buffer
                                       If l < Length (print[i]) Then begin
                                          str:= copy(print[i], l, 255 );
                                          //ShowMessage(str);
                                          StrPcopy(@buf,str);
                                       End;
                                       // Enviar parte do Buffer...
                                       mt_sendbinserial (Message.LParamLo, porta, buf[0], 255);
                                       Sleep (100);
                                       l := l + 255;

                                       If l < Length(print[i]) Then GoTo Continua
                                       else mt_sendbinserial (Message.LParamLo, porta, a, 2);
                                    end else begin
                                       // Envio de menos de 256 bytes...
                                       //Armazenamos cada caracter da string no vetor Buffer
                                       Tam := Length(print[i]);
                                       StrPCopy (@buf, print[i]);
                                       // Enviar para a serial linha por linha...
                                       mt_sendbinserial ( Message.LParamLo, porta, buf[0], Tam );
                                       a := 10;
                                       Sleep (100);
                                       mt_sendbinserial (Message.LParamLo, porta , a, 2);

                                    End;
                                 End;
                                 //Inclui 4 espaos no fim da nota
                                 mt_sendbinserial ( Message.LParamLo, porta, a, 2);
                                 Sleep (100);
                                 mt_sendbinserial (Message.LParamLo, porta, a, 2);
                                 Sleep (100);
                                 mt_sendbinserial (Message.LParamLo, porta, a, 2);
                                 Sleep (100);
                                 mt_sendbinserial (Message.LParamLo, porta, a, 2);
                                 Sleep (100);
                              end;
                             {*************************************************************
                              *           Fim da Rotina de Impressao                      *
                              *************************************************************}

                           end else begin
                              TimerPasso(Message.LParamLo);
                              palavra[Message.LParamLo]:= '';
                           end;
                        end else begin
                           //Caso no seja finalizao dos pedidos efetua a consulta
                           if (cls_ComandosBanco.LancamentoProduto(palavra[Message.LParamLo], NumeroProd[Message.LParamLo], Message.LParamLo ) = True) then begin
                              passo[Message.LParamLo]:=passo[Message.LParamLo]+1;
                              TimerPasso(Message.LParamLo);
                              palavra[Message.LParamLo]:= '';
                           end else begin
                              TimerPasso(Message.LParamLo);
                              palavra[Message.LParamLo]:= '';
                           end;
                        end;
                     end;// Case 5
                     6: begin
                        if (palavra[Message.LParamLo] = '') or (StrToFloat(palavra[Message.LParamLo]) = 0 )then begin
                           passo[Message.LParamLo]:= passo[Message.LParamLo] + 1;
                           TimerPasso(Message.LParamLo);
                           palavra[Message.LParamLo]:= '';
                        end else begin
                           if (cls_ComandosBanco.LancamentoProdutoCesta(StrToFloat(palavra[Message.LParamLo]), NumeroProd[Message.LParamLo], Message.LParamLo) = True) then begin
                              NumeroProd[Message.LParamLo] := NumeroProd[Message.LParamLo] + 1;
                              passo[Message.LParamLo] := passo[Message.LParamLo] - 1;
                              TimerPasso(Message.LParamLo);
                              palavra[Message.LParamLo] := '';
                           end; //If 2
                        end; //If 1
                     end;//Case 6
                     7: begin
                        If palavra[Message.LParamLo] = '' then begin
                           passo[Message.LParamLo] := passo[Message.LParamLo] - 1;
                           TimerPasso (message.LParamLo);
                           palavra[Message.LParamLo]:= '';
                        end else begin
                           // Se a observao existir efetua mostra no display e inclui no pedido
                           if (cls_ComandosBanco.LancamentoObservacao(StrToInt(palavra[Message.LParamLo]), NumeroProd[Message.LParamLo], Message.LParamLo) = True) then begin
                              mt_linefeed (Message.LParamLo);
                              mt_carret (Message.LParamLo);
                              StrPcopy (@Msg, PedidoG[Message.LParamLo].Cesta[NumeroProd[Message.LParamLo]].Observ);
                              mt_dispstr( Message.LParamLo, Msg[1]);
                              passo[Message.LParamLo] := passo[Message.LParamLo] +1;
                              palavra [Message.LParamLo]:= '';
                           end else begin
                              //Se a observao no existir limpa a string palavra
                              TimerPasso (Message.LParamLo);
                              palavra[Message.LParamLo]:= '';
                           end;
                        end; // If 1
                     end; // Case 7
                     {OBSERVAO}
                     8: begin
                        if PedidoG[Message.LParamLo].Cesta[NumeroProd[Message.LParamLo]].Obs = '' then begin
                           PedidoG[Message.LParamLo].Cesta[NumeroProd[Message.LParamLo]].Obs := PedidoG[Message.LParamLo].Cesta[NumeroProd[Message.LParamLo]].Observ;
                           passo[Message.LParamLo]:= passo[Message.LParamLo] - 1;
                           TimerPasso(Message.LParamLo);
                           palavra[Message.LParamLo]:= '';
                        end else begin
                           PedidoG[Message.LParamLo].Cesta[NumeroProd[Message.LParamLo]].Obs := PedidoG[Message.LParamLo].Cesta[NumeroProd[Message.LParamLo]].Obs + '+' + PedidoG[Message.LParamLo].Cesta[NumeroProd[Message.LParamLo]].Observ;
                           passo[Message.LParamLo]:= passo[Message.LParamLo] - 1;
                           TimerPasso(Message.LParamLo);
                           palavra[Message.LParamLo]:= '';
                        end;
                     end; // Case 8
               end;
              {*********************************************************
               *  Se a tecla foi ESC segue o seguinte procedimento     *
               *********************************************************}
               end else if (buf[0] = 27) then begin
                  peso[message.LParamLo]:= false;
                  sendcod[0]:= 0;
                  TimerPasso(Message.LParamLo);
                  palavra[Message.LParamLo]:='';
                  case passo[Message.LParamLo] of
                     1: TimerPasso(Message.LParamLo);
                     2: begin
                        passo[Message.LParamLo] := passo[Message.LParamLo] - 1;
                        TimerPasso(Message.LParamLo);
                     end;
                     3: begin
                        passo[Message.LParamLo] := passo[Message.LParamLo] - 1;
                        TimerPasso(Message.LParamLo);
                     end;
                     4: begin
                        passo[Message.LParamLo] := passo[Message.LParamLo] - 1;
                        TimerPasso(Message.LParamLo);
                     end;
                     5: begin
                        passo[Message.LParamLo] := passo[Message.LParamLo] - 1;
                        TimerPasso(Message.LParamLo);
                     end;
                     6: begin
                        passo[Message.LParamLo] := passo[Message.LParamLo] - 1;
                        TimerPasso(Message.LParamLo);
                     end;
                     7: begin
                        passo[Message.LParamLo] := passo[Message.LParamLo] - 1;
                        TimerPasso(Message.LParamLo);
                     end;
                     8: begin
                        passo[Message.LParamLo]:= passo[Message.LParamLo]- 1;
                        TimerPasso(Message.LParamLo);
                     end;
                     20: begin
                        passo[Message.LParamLo]:= 21;
                        TimerPasso(Message.LParamLo);
                     end;
                  end;
               end;
            end;
         end;
         // Busca o endereo IP do ID correspondente
         retorna_IP(Message.LParamLo);

      end

//****************************************************************************************
         // IDvGetSetupSerial - Verifica a configurao da serial do microterminal
//****************************************************************************************
      else if (Message.WParam = IDvGetSetupSerial) then
      begin
         // Recebe as configuraes enviadas pelo terminal
         mt_getconfigserial(Message.LParamLo, configserial);

         // Cada combo recebe sua respctiva configurao de serial
         cbBaud.Text := IntToStr(configserial.Setup.baud);
         cbBits.Text := IntToStr(configserial.Setup.bits);

         if configserial.Setup.parity = 0 then
            cbParidade.Text := 'Nenhum'
         else if configserial.Setup.parity = 1 then
            cbParidade.Text := 'Impar'
         else if configserial.Setup.parity = 2 then
            cbParidade.Text := 'Par'
         else if configserial.Setup.parity = 3 then
            cbParidade.Text := 'Marca'
         else if configserial.Setup.parity = 4 then
            cbParidade.Text := 'Espao';

         cbStop.Text := IntToStr(configserial.Setup.stops);

         if configserial.Setup.handshaking = 0 then
            cbHand.Text := 'Nenhum'
         else if configserial.Setup.handshaking = 1 then
            cbHand.Text := 'CTS / RTS';
      end;
   end;
   inherited WndProc(Message);
end;

//********************************************************************************************************
// Evento: Timer1
//********************************************************************************************************
//                                                                                                       *
// Data de Criao: 14/05/2008                                                                           *
//                                                                                                       *
// Descrio: Recebe os terminais que se conectam e inclui na lista de conectados                        *
//                                                                                                       *
//********************************************************************************************************

procedure TFrmPrincipal.Timer1Timer(Sender: TObject);
var i: Integer;
    terminal: Integer;
begin
 // Recebe o index de um item selecionado na lista de terminais conectados.
    if (ListBox1.Items.Text <> '') then
    begin
        terminal := ListBox1.ItemIndex;
    end;

    // Limpa a Lista de terminais antes de atualiza-la.
    ListBox1.Clear;

    // Recebe o id dos terminais conectados.
    tabcon := mt_connectlist;

    i := 0;
    while (i < 255) do
    begin
        if (tabcon.TSOCK[i] <> 0) then
        begin
            // Transforma o ID em um endereo vlido.
            auxIP.S_addr := tabcon.TSOCK[i];
            // Formata para um endereo de IP pontuado e exibe na lista de conectados.
            ListBox1.Items.Add(inet_ntoa(auxIP));
            // Seleciona o primeiro item da lista de terminais conectados.
            ListBox1.ItemIndex := 0;
        end;
        i := i + 1;
    end;

    // Seleciona o terminal que estava selecionado anteriormente na lista de terminais conectados.
    if ((ListBox1.Items.Text <> '') And (ListBox1.Items.Count = terminal + 1)) then
    begin
        ListBox1.ItemIndex := terminal;
    end;

    // Envia vLive para todos os terminais conctados.
    i := 0;
    while (i < 255) do
    begin
        if (tabcon.TSOCK[i] <> 0) then
        begin
            mt_sendlive(i);
        end;
        i := i + 1;
    end;

end;

//********************************************************************************************************
// Evento: btnEnviarConfSerial
//********************************************************************************************************
//
// Data de Criao: 14/05/2008
//
// Descrio: Envia a configurao serial para o Microterminal
//
//********************************************************************************************************

procedure TFrmPrincipal.btnEnviarConfSerialClick(Sender: TObject);
var
    config: TSetupSerial;
    configuracao: ARG_COM_SETUPSERIAL;
begin
    Try
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) OR (cbPorta.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal ou uma porta.','Serial',48)
    end
    else
    begin
        // Selecionando a COM
        configuracao.com := cbPorta.ItemIndex;

        // Recebendo toda configurao da serial
        config.baud := StrToInt(cbBaud.Text);
        config.bits := StrToInt(cbBits.Text);

        if cbParidade.Text = ('Nenhum') then
            config.parity := 0
        else if cbParidade.Text = ('Impar') then
            config.parity := 1
        else if cbParidade.Text = ('Par') then
            config.parity := 2
        else if cbParidade.Text = ('Marca') then
            config.parity := 3
        else if cbParidade.Text = ('Espao')then
            config.parity := 4;

        config.stops := StrToInt(cbStop.Text);

        if cbHand.Text = ('Nenhum') then
        begin
            config.handshaking := 0;
        end
        else
        begin
            config.handshaking := 1;
        end;

        configuracao.Setup := config;

        // Envia configurao para o terminal
        if mt_sendconfigserial(ListBox1.ItemIndex+1,configuracao) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end
        else
        begin
          //Reinicia o microterminal para que o mesmo assuma a nova configurao
           mt_restart(ListBox1.ItemIndex+1);
        end;
    end;
    Except
        Application.MessageBox('Preencha corretamente os campos.','Serial',16);
    end;


end;
//********************************************************************************************************
// Evento: btnRecebeConfSerial
//********************************************************************************************************
//
// Data de Criao: 14/05/2008
//
// Descrio: Recebe a configurao serial do Microterminal
//
//********************************************************************************************************

procedure TFrmPrincipal.btnRecebeConfSerialClick(Sender: TObject);
var
    com: BYTE;
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) OR (cbPorta.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal ou uma porta.','Serial',48)
    end
    else
    begin
        com := cbPorta.ItemIndex;
        // Requisita a configurao da serial do terminal
        if mt_reqconfigserial(ListBox1.ItemIndex+1,com) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: btAtualizar
//********************************************************************************************************
//
// Data de Criao: 14/05/2008
//
// Descrio: Atualiza a lista de terminais conectados
//
//********************************************************************************************************

procedure TFrmPrincipal.btAtualizaClick(Sender: TObject);
begin
    Timer1Timer(Sender);
end;


//********************************************************************************************************
// Evento: btImprimi
//********************************************************************************************************
//
// Data de Criao: 14/05/2008
//
// Descrio: Imprime todos os pedidos feitos em um determinado microterminal
//
//********************************************************************************************************

procedure TFrmPrincipal.btImprimiClick(Sender: TObject);
label continua;
var Buffer: array [0..255] of byte;
    tam: byte;
    com: byte;
    i: integer;
    j: integer;
    k: integer;
    str:string;
    a: byte;
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) OR (cbPorta.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal ou uma porta.','Serial',48);
        exit;
    end else begin
       com := cbPorta.ItemIndex;
       a := 10;
       mt_setenableserial (ListBox1.ItemIndex + 1  , com, 1);
    end;
    For k:= 0 to ListBox2.Items.Count - 1 do begin
       tam:= length(ListBox2.Items[k]);
       try
          if tam > 256 then //Se tiver mais de 256 caracteres a string deve ser dividida
          continua: begin                //pois acima de 256 ir travar
             For j := 0 To 255 do buffer[j]:=0;  //Zera o vetor Buffer
             If i < tam Then begin
                str:= copy(ListBox2.Items[k], i, 255 );
                StrPcopy(@buffer,str);
             End;
             // Enviar parte do Buffer...
             mt_sendbinserial (ListBox1.ItemIndex + 1, com, buffer[0], 255);
             Sleep (100);
             i := i + 255;
             If i < tam Then GoTo Continua
             else mt_sendbinserial (ListBox1.ItemIndex + 1, com, a, 2);
          end else begin
             For j := 0 To 255 do buffer[j]:=0;  //Zera o vetor Buffer
             // Envio de menos de 256 bytes...
             //Armazenamos cada caracter da string no vetor Buffer
             StrPCopy (@buffer, ListBox2.Items[k]);
             // Enviar para a serial linha por linha...
             mt_sendbinserial ( ListBox1.ItemIndex + 1, com, buffer[0], Tam );
             Sleep (100);
             mt_sendbinserial (ListBox1.ItemIndex + 1, com , a, 2);
          End;
       except
       end;
    end;
    //Inclui 3 espaos no fim da nota
    mt_sendbinserial ( ListBox1.ItemIndex + 1, com , a, 2);
    Sleep (100);
    mt_sendbinserial (ListBox1.ItemIndex + 1, com , a, 2);
    Sleep (100);
    mt_sendbinserial (ListBox1.ItemIndex + 1, com , a, 2);
    sleep (100);
end;

//********************************************************************************************************
// Evento: btIniciar
//********************************************************************************************************
//
// Data de Criao: 14/05/2008
//
// Descrio: Inicializa / Finaliza a DLL
//
//********************************************************************************************************

procedure TFrmPrincipal.btIniciarClick(Sender: TObject);
begin
   if btIniciar.Caption = '&Iniciar' then begin
      //Inicia a DLL
      mt_startserver(FrmPrincipal.Handle, 0, MsgReceiveData);
      //Configurao Inicial
      cbAlias.Enabled := False;
      btIniciar.Caption := '&Terminar';
   end else begin
      mt_finishserver;
      btIniciar.Caption := '&Iniciar';
      cbAlias.Enabled := True;
   end;
end;

//********************************************************************************************************
// Evento: ConfBD
//********************************************************************************************************
//
// Data de Criao: 20/05/2008
//
// Descrio: Configurao ODBC
//
//********************************************************************************************************

procedure TFrmPrincipal.ConfBDClick(Sender: TObject);
begin
    //Deixa a var session inativa, para que futuramente o ODBC possa ser atualizado
     ShellExecute (0,pchar('open'),pchar('Odbcad32.exe'),nil,pchar('Odbcad32.exe'),Sw_Show);

end;
//********************************************************************************************************
// Evento: btSair
//********************************************************************************************************
//
// Data de Criao: 14/05/2008
//
// Descrio: Finaliza a DLL e sai do programa
//
//********************************************************************************************************

procedure TFrmPrincipal.bSairClick(Sender: TObject);
begin
   if (MessageDlg('Deseja Sair',mtConfirmation ,[mbYes,mbNo],0)= idYes) then begin
      try
         if btIniciar.Caption = 'Iniciar' then mt_finishserver;
         Close;
      except
      end;
   end;
end;

//********************************************************************************************************
// Evento: FormCreat
//********************************************************************************************************
//
// Data de Criao: 20/05/2008
//
// Descrio: Configurao Inicial
//
//********************************************************************************************************

procedure TFrmPrincipal.FormCreate(Sender: TObject);
var index : integer;
begin
    //Desativa conexo
    Session.Active := false;
    //Limpa combo box do Alias
    CbAlias.Clear;
    //Reativa a varivel session para que os Alias sejam carregados e atualizados
    Session.Active := true;
    //Monta lista de Alias no ComboBox
    Session.GetAliasNames (CBAlias.Items);
    for index:= 0 to 255 do passo[index]:= 0;

    if cbAlias.Enabled = False then btIniciar.Enabled:= False;


end;

//********************************************************************************************************
// Evento: cbAlias
//********************************************************************************************************
//
// Data de Criao: 20/05/2008
//
// Descrio: Mostra as tabelas existentes no banco
//
//********************************************************************************************************

procedure TFrmPrincipal.cbAliasChange(Sender: TObject);
begin
  try
    //Mostra as tabelas do Alias selecionado no ListBox
    Session.GetTableNames (CbAlias.text,'',true,false, LbProd.Items);
    btIniciar.Enabled := True;
  except
    showmessage ('Falha na conexo');
  end;
end;

//********************************************************************************************************
// Evento: TimerPasso
//********************************************************************************************************
//
// Data de Criao: 20/05/2008
//
// Descrio: Responsvel pelas fases no terminal e envio de tela.
//
//********************************************************************************************************

procedure TfrmPrincipal.TimerPasso(qconec: integer);

var

   MsgStr: array [1..256] of byte;

 

begin

 

   case passo[qconec] of

     0: passo[qconec] := passo[qconec] + 1;

     1: begin

        mt_formfeed (qconec);

        //Envia a 1 tela ao terminal (Operador)

        StrPcopy (@MsgStr, 'Operador:');

        sleep (300);

        mt_dispstr (qconec, MsgStr[1]);

        sleep (900);

     end;

     2: begin

        mt_formfeed (qconec);

        //Envia a 2 tela ao terminal (Cartao)

        StrPcopy (@MsgStr, 'Cartao:');

        sleep (300);

        mt_dispstr (qconec, MsgStr[1]);

         sleep (900);

     end;

     3: begin

        mt_formfeed (qconec);

        //Envia a 3 tela ao terminal (Local)

        StrPcopy (@MsgStr, 'Local:');

        sleep (300);

        mt_dispstr (qconec, MsgStr[1]);

        sleep (900);

     end;

     4: begin

        mt_formfeed (qconec);

        //Envia a 4 tela ao terminal (Guia)

        StrPcopy (@MsgStr, 'Guia:');

        sleep (300);

        mt_dispstr (qconec, MsgStr[1]);

        sleep (100);

     end;

     5: begin

        mt_formfeed (qconec);

        //Envia a 5 tela ao terminal (Produto)

        StrPcopy (@MsgStr, 'Produto:');

        sleep (300);

        mt_dispstr (qconec, MsgStr[1]);

        sleep (100);

     end;

     6: begin

        //Envia a tela de pedido

        // Enviando a 1 linha com a descrio do produto pedido

        mt_formfeed (qconec);

        Sleep(200);

        StrPcopy (@MsgStr, PedidoG[qconec].Cesta[NumeroProd[qconec]].DescricaoProduto);

        mt_dispstr (qconec, MsgStr[1]);

        sleep (200);

        // Enviando a 2 linha com o valor do produto pedido

        mt_linefeed (qconec);

        mt_carret (qconec);

        Sleep(100);

        StrPcopy (@MsgStr, FormatCurr('#.00', PedidoG[qconec].Cesta[NumeroProd[qconec]].Valor));

        mt_dispstr (qconec, MsgStr[1]);

        sleep (200);

        // Incluindo o local de digitao de Qtd posicionando o cursor

        mt_gotoxy (qconec, 2, 10);

        StrPcopy (@MsgStr, 'Qtd:');

        mt_dispstr (qconec, MsgStr[1]);

        sleep (100);

     end;

     7: begin

        //Envia a tela de observao

        mt_formfeed (qconec);

        sleep (300);

        StrPcopy (@MsgStr, 'Observacao:');

        mt_dispstr (qconec, MsgStr[1]);

        sleep (100);

     end;

 

  end;

end;

 



//********************************************************************************************************
// Evento: Button1
//********************************************************************************************************
//
// Data de Criao: 02/06/2008
//
// Descrio: Responsvel pela atualizao da lista ODBC.
//
//********************************************************************************************************
procedure TFrmPrincipal.Button1Click(Sender: TObject);
begin
  Session.Active := false;
  //Limpa combo box
  CbAlias.Clear;
  //Reativa a varivel session para que os Alias sejam carregados e atualizados
  Session.Active := true;
  //Monta lista de Alias no ComboBox
  session.GetAliasNames (CBAlias.Items);
end;

end.
