/****************************************************************************
* Aplicativo : SMTGeR... Servidor de Microterminais Gertec - Restaurante    *
* Autor		 : Ana Lcia S. Melo 										    *
* Referncia : SMTGeR - Programa Servidor para Micro Terminais              *
* Data       : 07/07/08													    *
* Ambiente   : Visual C++ 2005 (Express Edition)                            *
* Fonte      : Form1.h														*
* Objetivo   : Exemplificar uma aplicao para microterminais simulando um	*
*			   programa de restaurante.									   	*
* Notas		 : Este fonte destina-se exclusivamente como material de	    *
*			   auxilio a desenvolvedores de aplicaes para produtos Gertec.*
****************************************************************************/
#include "pmtger.h"		//chamadas da DLL
#include "structs.h"	//Estrurura para utilizao na DLL
#include "structres.h"	//Estrutura para utilizao no projeto
#include <windows.h>
#include <stdio.h>
#include <iostream>
#include <string>
#include <oledb.h>

#define COMUNICATION_MSG WM_USER + 1
#define CONNECT_MSG WM_USER + 2

#pragma once


namespace SMTGer {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Security::Permissions;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::Runtime::InteropServices;
	using namespace std ;
	using namespace System::Data::Sql;
	using namespace System::Data::SqlTypes;
	using namespace System::Data::OleDb;
	using namespace System::IO;



	//DECLARAO GLOBAL: Declarao das variaveis globais para utilizao futura
	HINSTANCE Hpmtg;
	int qconect;
	int qconec;
	TTABSOCK tabcon;
	
	int passo[256];
	char palavra[256][40];
	int peso[256];
	int cancela;

	int NumeroProd [256];
	PedidoType PedidoG[256];
	
//	
	LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM) ; 


	/// <summary>
	/// Summary for Form1
	///
	/// WARNING: If you change the name of this class, you will need to change the
	///          'Resource File Name' property for the managed resource compiler tool
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{
			InitializeComponent();
			//
			//TODO: Add the constructor code here
			//
		}

	protected:

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}

	private: System::Windows::Forms::TabControl^  tabControl1;
	private: System::Windows::Forms::TabPage^  tabPage1;
	private: System::Windows::Forms::TabPage^  tabPage2;
	private: System::Windows::Forms::TabPage^  tabPage3;
	private: System::Windows::Forms::MenuStrip^  menuStrip1;
	private: System::Windows::Forms::ToolStripMenuItem^  iniciarToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  sairToolStripMenuItem;
	private: System::Windows::Forms::Label^  label1;
	private: System::Windows::Forms::ListBox^  VConectados;
	private: System::Windows::Forms::GroupBox^  txgateway;

	private: System::Windows::Forms::ListBox^  listBox1;
	private: System::Windows::Forms::Label^  lbInform;

	private: System::Windows::Forms::Timer^  timer1;
	private: System::Windows::Forms::Timer^  timerConec;
	private: System::Windows::Forms::Label^  label2;
	private: System::Windows::Forms::TextBox^  txPass;
	private: System::Windows::Forms::TextBox^  txUser;
	private: System::Windows::Forms::TextBox^  txBanco;
	private: System::Windows::Forms::TextBox^  txServidor;
	private: System::Windows::Forms::Label^  label5;
	private: System::Windows::Forms::Label^  label4;
	private: System::Windows::Forms::Label^  label3;
	private: System::Windows::Forms::RadioButton^  bdSql;
	private: System::Windows::Forms::TextBox^  txbancoac;

	private: System::Windows::Forms::Label^  label6;
	private: System::Windows::Forms::RadioButton^  bdAccess;
	private: System::Data::OleDb::OleDbConnection^  oleDbConnection1;
	private: System::Data::OleDb::OleDbCommand^  oleDbCommand1;

	private: System::Windows::Forms::GroupBox^  groupBox2;
	private: System::Windows::Forms::Label^  label13;
	private: System::Windows::Forms::Label^  label12;
	private: System::Windows::Forms::Label^  label11;
	private: System::Windows::Forms::Label^  label10;
	private: System::Windows::Forms::Label^  label9;
	private: System::Windows::Forms::Label^  label8;
	private: System::Windows::Forms::ComboBox^  cbHand;
	private: System::Windows::Forms::ComboBox^  cbStop;
	private: System::Windows::Forms::ComboBox^  cbParidade;
	private: System::Windows::Forms::ComboBox^  cbBits;
	private: System::Windows::Forms::ComboBox^  cbBaud;
	private: System::Windows::Forms::ComboBox^  cbPorta;
	private: System::Windows::Forms::Button^  btRecebeConfSerial;
	private: System::Windows::Forms::Button^  btEnviaConfSerial;
	private: System::Windows::Forms::Timer^  timerEvento;
	private: System::Windows::Forms::GroupBox^  groupBox4;
	private: System::Windows::Forms::GroupBox^  groupBox3;

	private: System::Windows::Forms::Label^  label16;
	private: System::Windows::Forms::Label^  label15;
	private: System::Windows::Forms::Label^  label14;
	private: System::Windows::Forms::Label^  label7;
	private: System::Windows::Forms::CheckBox^  ckReqPeso;

	private: System::Windows::Forms::TextBox^  txPosPeso;

	private: System::Windows::Forms::TextBox^  txRecPeso;

	private: System::Windows::Forms::TextBox^  txDigPeso;

	private: System::Windows::Forms::TextBox^  txComBalanca;

	private: System::Windows::Forms::TextBox^  txComanPeso;
	private: System::Windows::Forms::CheckBox^  OpImp;

	private: System::Windows::Forms::Button^  btImprimi;
	private: System::Windows::Forms::TextBox^  txComImp;

	private: System::Windows::Forms::Label^  label17;
	private: System::Windows::Forms::TextBox^  txway;
	private: System::Windows::Forms::Label^  label18;

	private: System::Windows::Forms::Button^  btGravar;















	private: System::ComponentModel::IContainer^  components;

	protected: 
	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->components = (gcnew System::ComponentModel::Container());
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(Form1::typeid));
			this->tabControl1 = (gcnew System::Windows::Forms::TabControl());
			this->tabPage1 = (gcnew System::Windows::Forms::TabPage());
			this->btGravar = (gcnew System::Windows::Forms::Button());
			this->txway = (gcnew System::Windows::Forms::TextBox());
			this->label18 = (gcnew System::Windows::Forms::Label());
			this->txbancoac = (gcnew System::Windows::Forms::TextBox());
			this->label6 = (gcnew System::Windows::Forms::Label());
			this->bdAccess = (gcnew System::Windows::Forms::RadioButton());
			this->bdSql = (gcnew System::Windows::Forms::RadioButton());
			this->txPass = (gcnew System::Windows::Forms::TextBox());
			this->txUser = (gcnew System::Windows::Forms::TextBox());
			this->txBanco = (gcnew System::Windows::Forms::TextBox());
			this->txServidor = (gcnew System::Windows::Forms::TextBox());
			this->label5 = (gcnew System::Windows::Forms::Label());
			this->label4 = (gcnew System::Windows::Forms::Label());
			this->label3 = (gcnew System::Windows::Forms::Label());
			this->label2 = (gcnew System::Windows::Forms::Label());
			this->tabPage2 = (gcnew System::Windows::Forms::TabPage());
			this->groupBox2 = (gcnew System::Windows::Forms::GroupBox());
			this->btEnviaConfSerial = (gcnew System::Windows::Forms::Button());
			this->btRecebeConfSerial = (gcnew System::Windows::Forms::Button());
			this->label13 = (gcnew System::Windows::Forms::Label());
			this->label12 = (gcnew System::Windows::Forms::Label());
			this->label11 = (gcnew System::Windows::Forms::Label());
			this->label10 = (gcnew System::Windows::Forms::Label());
			this->label9 = (gcnew System::Windows::Forms::Label());
			this->label8 = (gcnew System::Windows::Forms::Label());
			this->cbHand = (gcnew System::Windows::Forms::ComboBox());
			this->cbStop = (gcnew System::Windows::Forms::ComboBox());
			this->cbParidade = (gcnew System::Windows::Forms::ComboBox());
			this->cbBits = (gcnew System::Windows::Forms::ComboBox());
			this->cbBaud = (gcnew System::Windows::Forms::ComboBox());
			this->cbPorta = (gcnew System::Windows::Forms::ComboBox());
			this->tabPage3 = (gcnew System::Windows::Forms::TabPage());
			this->groupBox4 = (gcnew System::Windows::Forms::GroupBox());
			this->btImprimi = (gcnew System::Windows::Forms::Button());
			this->txComImp = (gcnew System::Windows::Forms::TextBox());
			this->label17 = (gcnew System::Windows::Forms::Label());
			this->OpImp = (gcnew System::Windows::Forms::CheckBox());
			this->groupBox3 = (gcnew System::Windows::Forms::GroupBox());
			this->txPosPeso = (gcnew System::Windows::Forms::TextBox());
			this->txRecPeso = (gcnew System::Windows::Forms::TextBox());
			this->txDigPeso = (gcnew System::Windows::Forms::TextBox());
			this->txComBalanca = (gcnew System::Windows::Forms::TextBox());
			this->txComanPeso = (gcnew System::Windows::Forms::TextBox());
			this->ckReqPeso = (gcnew System::Windows::Forms::CheckBox());
			this->label16 = (gcnew System::Windows::Forms::Label());
			this->label15 = (gcnew System::Windows::Forms::Label());
			this->label14 = (gcnew System::Windows::Forms::Label());
			this->label7 = (gcnew System::Windows::Forms::Label());
			this->menuStrip1 = (gcnew System::Windows::Forms::MenuStrip());
			this->iniciarToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->sairToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->VConectados = (gcnew System::Windows::Forms::ListBox());
			this->txgateway = (gcnew System::Windows::Forms::GroupBox());
			this->listBox1 = (gcnew System::Windows::Forms::ListBox());
			this->lbInform = (gcnew System::Windows::Forms::Label());
			this->timer1 = (gcnew System::Windows::Forms::Timer(this->components));
			this->timerConec = (gcnew System::Windows::Forms::Timer(this->components));
			this->oleDbConnection1 = (gcnew System::Data::OleDb::OleDbConnection());
			this->oleDbCommand1 = (gcnew System::Data::OleDb::OleDbCommand());
			this->timerEvento = (gcnew System::Windows::Forms::Timer(this->components));
			this->tabControl1->SuspendLayout();
			this->tabPage1->SuspendLayout();
			this->tabPage2->SuspendLayout();
			this->groupBox2->SuspendLayout();
			this->tabPage3->SuspendLayout();
			this->groupBox4->SuspendLayout();
			this->groupBox3->SuspendLayout();
			this->menuStrip1->SuspendLayout();
			this->txgateway->SuspendLayout();
			this->SuspendLayout();
			// 
			// tabControl1
			// 
			this->tabControl1->Controls->Add(this->tabPage1);
			this->tabControl1->Controls->Add(this->tabPage2);
			this->tabControl1->Controls->Add(this->tabPage3);
			this->tabControl1->Location = System::Drawing::Point(11, 46);
			this->tabControl1->Name = L"tabControl1";
			this->tabControl1->SelectedIndex = 0;
			this->tabControl1->Size = System::Drawing::Size(342, 279);
			this->tabControl1->TabIndex = 1;
			// 
			// tabPage1
			// 
			this->tabPage1->Controls->Add(this->btGravar);
			this->tabPage1->Controls->Add(this->txway);
			this->tabPage1->Controls->Add(this->label18);
			this->tabPage1->Controls->Add(this->txbancoac);
			this->tabPage1->Controls->Add(this->label6);
			this->tabPage1->Controls->Add(this->bdAccess);
			this->tabPage1->Controls->Add(this->bdSql);
			this->tabPage1->Controls->Add(this->txPass);
			this->tabPage1->Controls->Add(this->txUser);
			this->tabPage1->Controls->Add(this->txBanco);
			this->tabPage1->Controls->Add(this->txServidor);
			this->tabPage1->Controls->Add(this->label5);
			this->tabPage1->Controls->Add(this->label4);
			this->tabPage1->Controls->Add(this->label3);
			this->tabPage1->Controls->Add(this->label2);
			this->tabPage1->Location = System::Drawing::Point(4, 22);
			this->tabPage1->Name = L"tabPage1";
			this->tabPage1->Padding = System::Windows::Forms::Padding(3);
			this->tabPage1->Size = System::Drawing::Size(334, 253);
			this->tabPage1->TabIndex = 0;
			this->tabPage1->Text = L"Config. Banco";
			this->tabPage1->UseVisualStyleBackColor = true;
			// 
			// btGravar
			// 
			this->btGravar->Location = System::Drawing::Point(112, 222);
			this->btGravar->Name = L"btGravar";
			this->btGravar->Size = System::Drawing::Size(75, 23);
			this->btGravar->TabIndex = 7;
			this->btGravar->Text = L"Gravar";
			this->btGravar->UseVisualStyleBackColor = true;
			this->btGravar->Click += gcnew System::EventHandler(this, &Form1::btGravar_Click);
			// 
			// txway
			// 
			this->txway->Enabled = false;
			this->txway->Location = System::Drawing::Point(137, 192);
			this->txway->Name = L"txway";
			this->txway->Size = System::Drawing::Size(145, 20);
			this->txway->TabIndex = 13;
			this->txway->TextChanged += gcnew System::EventHandler(this, &Form1::txway_TextChanged);
			// 
			// label18
			// 
			this->label18->AutoSize = true;
			this->label18->Enabled = false;
			this->label18->Location = System::Drawing::Point(81, 195);
			this->label18->Name = L"label18";
			this->label18->Size = System::Drawing::Size(48, 13);
			this->label18->TabIndex = 12;
			this->label18->Text = L"Caminho";
			// 
			// txbancoac
			// 
			this->txbancoac->Enabled = false;
			this->txbancoac->Location = System::Drawing::Point(136, 163);
			this->txbancoac->Name = L"txbancoac";
			this->txbancoac->Size = System::Drawing::Size(146, 20);
			this->txbancoac->TabIndex = 11;
			this->txbancoac->TextChanged += gcnew System::EventHandler(this, &Form1::txbancoac_TextChanged);
			// 
			// label6
			// 
			this->label6->AutoSize = true;
			this->label6->Enabled = false;
			this->label6->Location = System::Drawing::Point(81, 166);
			this->label6->Name = L"label6";
			this->label6->Size = System::Drawing::Size(38, 13);
			this->label6->TabIndex = 10;
			this->label6->Text = L"Banco";
			// 
			// bdAccess
			// 
			this->bdAccess->AutoSize = true;
			this->bdAccess->Location = System::Drawing::Point(15, 140);
			this->bdAccess->Name = L"bdAccess";
			this->bdAccess->Size = System::Drawing::Size(94, 17);
			this->bdAccess->TabIndex = 9;
			this->bdAccess->TabStop = true;
			this->bdAccess->Text = L"Banco Access";
			this->bdAccess->UseVisualStyleBackColor = true;
			this->bdAccess->CheckedChanged += gcnew System::EventHandler(this, &Form1::bdAccess_CheckedChanged);
			// 
			// bdSql
			// 
			this->bdSql->AutoSize = true;
			this->bdSql->Location = System::Drawing::Point(15, 10);
			this->bdSql->Name = L"bdSql";
			this->bdSql->Size = System::Drawing::Size(80, 17);
			this->bdSql->TabIndex = 8;
			this->bdSql->TabStop = true;
			this->bdSql->Text = L"Banco SQL";
			this->bdSql->UseVisualStyleBackColor = true;
			this->bdSql->CheckedChanged += gcnew System::EventHandler(this, &Form1::bdSql_CheckedChanged);
			// 
			// txPass
			// 
			this->txPass->Enabled = false;
			this->txPass->Location = System::Drawing::Point(136, 108);
			this->txPass->Name = L"txPass";
			this->txPass->Size = System::Drawing::Size(146, 20);
			this->txPass->TabIndex = 7;
			// 
			// txUser
			// 
			this->txUser->Enabled = false;
			this->txUser->Location = System::Drawing::Point(136, 82);
			this->txUser->Name = L"txUser";
			this->txUser->Size = System::Drawing::Size(146, 20);
			this->txUser->TabIndex = 6;
			// 
			// txBanco
			// 
			this->txBanco->Enabled = false;
			this->txBanco->Location = System::Drawing::Point(137, 58);
			this->txBanco->Name = L"txBanco";
			this->txBanco->Size = System::Drawing::Size(146, 20);
			this->txBanco->TabIndex = 5;
			this->txBanco->TextChanged += gcnew System::EventHandler(this, &Form1::txBanco_TextChanged);
			// 
			// txServidor
			// 
			this->txServidor->Enabled = false;
			this->txServidor->Location = System::Drawing::Point(137, 31);
			this->txServidor->Name = L"txServidor";
			this->txServidor->Size = System::Drawing::Size(145, 20);
			this->txServidor->TabIndex = 4;
			this->txServidor->TextChanged += gcnew System::EventHandler(this, &Form1::txServidor_TextChanged);
			// 
			// label5
			// 
			this->label5->AutoSize = true;
			this->label5->Enabled = false;
			this->label5->Location = System::Drawing::Point(81, 112);
			this->label5->Name = L"label5";
			this->label5->Size = System::Drawing::Size(53, 13);
			this->label5->TabIndex = 3;
			this->label5->Text = L"Password";
			// 
			// label4
			// 
			this->label4->AutoSize = true;
			this->label4->Enabled = false;
			this->label4->Location = System::Drawing::Point(81, 86);
			this->label4->Name = L"label4";
			this->label4->Size = System::Drawing::Size(43, 13);
			this->label4->TabIndex = 2;
			this->label4->Text = L"User ID";
			// 
			// label3
			// 
			this->label3->AutoSize = true;
			this->label3->Enabled = false;
			this->label3->Location = System::Drawing::Point(81, 62);
			this->label3->Name = L"label3";
			this->label3->Size = System::Drawing::Size(38, 13);
			this->label3->TabIndex = 1;
			this->label3->Text = L"Banco";
			// 
			// label2
			// 
			this->label2->AutoSize = true;
			this->label2->Enabled = false;
			this->label2->Location = System::Drawing::Point(81, 35);
			this->label2->Name = L"label2";
			this->label2->Size = System::Drawing::Size(46, 13);
			this->label2->TabIndex = 0;
			this->label2->Text = L"Servidor";
			// 
			// tabPage2
			// 
			this->tabPage2->Controls->Add(this->groupBox2);
			this->tabPage2->Location = System::Drawing::Point(4, 22);
			this->tabPage2->Name = L"tabPage2";
			this->tabPage2->Padding = System::Windows::Forms::Padding(3);
			this->tabPage2->Size = System::Drawing::Size(334, 253);
			this->tabPage2->TabIndex = 1;
			this->tabPage2->Text = L"Serial";
			this->tabPage2->UseVisualStyleBackColor = true;
			// 
			// groupBox2
			// 
			this->groupBox2->Controls->Add(this->btEnviaConfSerial);
			this->groupBox2->Controls->Add(this->btRecebeConfSerial);
			this->groupBox2->Controls->Add(this->label13);
			this->groupBox2->Controls->Add(this->label12);
			this->groupBox2->Controls->Add(this->label11);
			this->groupBox2->Controls->Add(this->label10);
			this->groupBox2->Controls->Add(this->label9);
			this->groupBox2->Controls->Add(this->label8);
			this->groupBox2->Controls->Add(this->cbHand);
			this->groupBox2->Controls->Add(this->cbStop);
			this->groupBox2->Controls->Add(this->cbParidade);
			this->groupBox2->Controls->Add(this->cbBits);
			this->groupBox2->Controls->Add(this->cbBaud);
			this->groupBox2->Controls->Add(this->cbPorta);
			this->groupBox2->Location = System::Drawing::Point(6, 8);
			this->groupBox2->Name = L"groupBox2";
			this->groupBox2->Size = System::Drawing::Size(318, 204);
			this->groupBox2->TabIndex = 13;
			this->groupBox2->TabStop = false;
			this->groupBox2->Text = L"Configurao";
			// 
			// btEnviaConfSerial
			// 
			this->btEnviaConfSerial->Location = System::Drawing::Point(232, 66);
			this->btEnviaConfSerial->Name = L"btEnviaConfSerial";
			this->btEnviaConfSerial->Size = System::Drawing::Size(75, 23);
			this->btEnviaConfSerial->TabIndex = 26;
			this->btEnviaConfSerial->Text = L"Envia";
			this->btEnviaConfSerial->UseVisualStyleBackColor = true;
			this->btEnviaConfSerial->Click += gcnew System::EventHandler(this, &Form1::btEnviaConfSerial_Click);
			// 
			// btRecebeConfSerial
			// 
			this->btRecebeConfSerial->Location = System::Drawing::Point(232, 24);
			this->btRecebeConfSerial->Name = L"btRecebeConfSerial";
			this->btRecebeConfSerial->Size = System::Drawing::Size(75, 23);
			this->btRecebeConfSerial->TabIndex = 25;
			this->btRecebeConfSerial->Text = L"Recebe";
			this->btRecebeConfSerial->UseVisualStyleBackColor = true;
			this->btRecebeConfSerial->Click += gcnew System::EventHandler(this, &Form1::btRecebeConfSerial_Click);
			// 
			// label13
			// 
			this->label13->AutoSize = true;
			this->label13->Location = System::Drawing::Point(11, 179);
			this->label13->Name = L"label13";
			this->label13->Size = System::Drawing::Size(62, 13);
			this->label13->TabIndex = 24;
			this->label13->Text = L"Handshake";
			// 
			// label12
			// 
			this->label12->AutoSize = true;
			this->label12->Location = System::Drawing::Point(11, 152);
			this->label12->Name = L"label12";
			this->label12->Size = System::Drawing::Size(44, 13);
			this->label12->TabIndex = 23;
			this->label12->Text = L"Stop Bit";
			// 
			// label11
			// 
			this->label11->AutoSize = true;
			this->label11->Location = System::Drawing::Point(11, 125);
			this->label11->Name = L"label11";
			this->label11->Size = System::Drawing::Size(49, 13);
			this->label11->TabIndex = 22;
			this->label11->Text = L"Paridade";
			// 
			// label10
			// 
			this->label10->AutoSize = true;
			this->label10->Location = System::Drawing::Point(11, 98);
			this->label10->Name = L"label10";
			this->label10->Size = System::Drawing::Size(24, 13);
			this->label10->TabIndex = 21;
			this->label10->Text = L"Bits";
			// 
			// label9
			// 
			this->label9->AutoSize = true;
			this->label9->Location = System::Drawing::Point(11, 71);
			this->label9->Name = L"label9";
			this->label9->Size = System::Drawing::Size(60, 13);
			this->label9->TabIndex = 20;
			this->label9->Text = L"Velocidade";
			// 
			// label8
			// 
			this->label8->AutoSize = true;
			this->label8->Location = System::Drawing::Point(11, 29);
			this->label8->Name = L"label8";
			this->label8->Size = System::Drawing::Size(32, 13);
			this->label8->TabIndex = 19;
			this->label8->Text = L"Porta";
			// 
			// cbHand
			// 
			this->cbHand->FormattingEnabled = true;
			this->cbHand->Items->AddRange(gcnew cli::array< System::Object^  >(2) {L"Nenhum", L"CTS / RTS"});
			this->cbHand->Location = System::Drawing::Point(79, 176);
			this->cbHand->Name = L"cbHand";
			this->cbHand->Size = System::Drawing::Size(137, 21);
			this->cbHand->TabIndex = 18;
			// 
			// cbStop
			// 
			this->cbStop->FormattingEnabled = true;
			this->cbStop->Items->AddRange(gcnew cli::array< System::Object^  >(2) {L"1", L"2"});
			this->cbStop->Location = System::Drawing::Point(79, 149);
			this->cbStop->Name = L"cbStop";
			this->cbStop->Size = System::Drawing::Size(137, 21);
			this->cbStop->TabIndex = 17;
			// 
			// cbParidade
			// 
			this->cbParidade->FormattingEnabled = true;
			this->cbParidade->Items->AddRange(gcnew cli::array< System::Object^  >(5) {L"Nenhum", L"Impar", L"Par", L"Marca", L"Espao"});
			this->cbParidade->Location = System::Drawing::Point(79, 122);
			this->cbParidade->Name = L"cbParidade";
			this->cbParidade->Size = System::Drawing::Size(137, 21);
			this->cbParidade->TabIndex = 16;
			// 
			// cbBits
			// 
			this->cbBits->FormattingEnabled = true;
			this->cbBits->Items->AddRange(gcnew cli::array< System::Object^  >(4) {L"5", L"6", L"7", L"8"});
			this->cbBits->Location = System::Drawing::Point(79, 95);
			this->cbBits->Name = L"cbBits";
			this->cbBits->Size = System::Drawing::Size(137, 21);
			this->cbBits->TabIndex = 15;
			// 
			// cbBaud
			// 
			this->cbBaud->FormattingEnabled = true;
			this->cbBaud->Items->AddRange(gcnew cli::array< System::Object^  >(9) {L"300", L"1200", L"2400", L"4800", L"9600", L"19200", 
				L"38400", L"57600", L"115200"});
			this->cbBaud->Location = System::Drawing::Point(79, 68);
			this->cbBaud->Name = L"cbBaud";
			this->cbBaud->Size = System::Drawing::Size(137, 21);
			this->cbBaud->TabIndex = 14;
			// 
			// cbPorta
			// 
			this->cbPorta->FormattingEnabled = true;
			this->cbPorta->Items->AddRange(gcnew cli::array< System::Object^  >(3) {L"COM1", L"COM2", L"COM3"});
			this->cbPorta->Location = System::Drawing::Point(79, 25);
			this->cbPorta->Name = L"cbPorta";
			this->cbPorta->Size = System::Drawing::Size(137, 21);
			this->cbPorta->TabIndex = 13;
			// 
			// tabPage3
			// 
			this->tabPage3->Controls->Add(this->groupBox4);
			this->tabPage3->Controls->Add(this->groupBox3);
			this->tabPage3->Location = System::Drawing::Point(4, 22);
			this->tabPage3->Name = L"tabPage3";
			this->tabPage3->Padding = System::Windows::Forms::Padding(3);
			this->tabPage3->Size = System::Drawing::Size(334, 253);
			this->tabPage3->TabIndex = 2;
			this->tabPage3->Text = L"Opes Serial";
			this->tabPage3->UseVisualStyleBackColor = true;
			// 
			// groupBox4
			// 
			this->groupBox4->AutoSize = true;
			this->groupBox4->Controls->Add(this->btImprimi);
			this->groupBox4->Controls->Add(this->txComImp);
			this->groupBox4->Controls->Add(this->label17);
			this->groupBox4->Controls->Add(this->OpImp);
			this->groupBox4->Location = System::Drawing::Point(169, 6);
			this->groupBox4->Name = L"groupBox4";
			this->groupBox4->Size = System::Drawing::Size(157, 209);
			this->groupBox4->TabIndex = 1;
			this->groupBox4->TabStop = false;
			this->groupBox4->Text = L"Impressora";
			// 
			// btImprimi
			// 
			this->btImprimi->Location = System::Drawing::Point(32, 119);
			this->btImprimi->Name = L"btImprimi";
			this->btImprimi->Size = System::Drawing::Size(79, 25);
			this->btImprimi->TabIndex = 9;
			this->btImprimi->Text = L"Imprimir";
			this->btImprimi->UseVisualStyleBackColor = true;
			this->btImprimi->Click += gcnew System::EventHandler(this, &Form1::btImprimi_Click);
			// 
			// txComImp
			// 
			this->txComImp->Location = System::Drawing::Point(92, 74);
			this->txComImp->Name = L"txComImp";
			this->txComImp->Size = System::Drawing::Size(29, 20);
			this->txComImp->TabIndex = 8;
			this->txComImp->Text = L"1";
			// 
			// label17
			// 
			this->label17->Location = System::Drawing::Point(16, 77);
			this->label17->Name = L"label17";
			this->label17->Size = System::Drawing::Size(59, 15);
			this->label17->TabIndex = 7;
			this->label17->Text = L"Porta COM";
			// 
			// OpImp
			// 
			this->OpImp->Location = System::Drawing::Point(15, 29);
			this->OpImp->Name = L"OpImp";
			this->OpImp->Size = System::Drawing::Size(115, 30);
			this->OpImp->TabIndex = 0;
			this->OpImp->Text = L"Imprimir Cupom de Pedido";
			this->OpImp->UseVisualStyleBackColor = true;
			// 
			// groupBox3
			// 
			this->groupBox3->Controls->Add(this->txPosPeso);
			this->groupBox3->Controls->Add(this->txRecPeso);
			this->groupBox3->Controls->Add(this->txDigPeso);
			this->groupBox3->Controls->Add(this->txComBalanca);
			this->groupBox3->Controls->Add(this->txComanPeso);
			this->groupBox3->Controls->Add(this->ckReqPeso);
			this->groupBox3->Controls->Add(this->label16);
			this->groupBox3->Controls->Add(this->label15);
			this->groupBox3->Controls->Add(this->label14);
			this->groupBox3->Controls->Add(this->label7);
			this->groupBox3->Location = System::Drawing::Point(6, 6);
			this->groupBox3->Name = L"groupBox3";
			this->groupBox3->Size = System::Drawing::Size(164, 209);
			this->groupBox3->TabIndex = 0;
			this->groupBox3->TabStop = false;
			this->groupBox3->Text = L"Balana";
			// 
			// txPosPeso
			// 
			this->txPosPeso->Location = System::Drawing::Point(117, 174);
			this->txPosPeso->Name = L"txPosPeso";
			this->txPosPeso->Size = System::Drawing::Size(29, 20);
			this->txPosPeso->TabIndex = 9;
			this->txPosPeso->Text = L"35";
			// 
			// txRecPeso
			// 
			this->txRecPeso->Location = System::Drawing::Point(117, 142);
			this->txRecPeso->Name = L"txRecPeso";
			this->txRecPeso->Size = System::Drawing::Size(29, 20);
			this->txRecPeso->TabIndex = 8;
			this->txRecPeso->Text = L"71";
			// 
			// txDigPeso
			// 
			this->txDigPeso->Location = System::Drawing::Point(117, 106);
			this->txDigPeso->Name = L"txDigPeso";
			this->txDigPeso->Size = System::Drawing::Size(29, 20);
			this->txDigPeso->TabIndex = 7;
			this->txDigPeso->Text = L"4";
			// 
			// txComBalanca
			// 
			this->txComBalanca->Location = System::Drawing::Point(117, 71);
			this->txComBalanca->Name = L"txComBalanca";
			this->txComBalanca->Size = System::Drawing::Size(29, 20);
			this->txComBalanca->TabIndex = 6;
			this->txComBalanca->Text = L"1";
			// 
			// txComanPeso
			// 
			this->txComanPeso->Location = System::Drawing::Point(117, 36);
			this->txComanPeso->Name = L"txComanPeso";
			this->txComanPeso->Size = System::Drawing::Size(29, 20);
			this->txComanPeso->TabIndex = 5;
			this->txComanPeso->Text = L"05";
			// 
			// ckReqPeso
			// 
			this->ckReqPeso->Location = System::Drawing::Point(9, 131);
			this->ckReqPeso->Name = L"ckReqPeso";
			this->ckReqPeso->Size = System::Drawing::Size(98, 43);
			this->ckReqPeso->TabIndex = 4;
			this->ckReqPeso->Text = L"Comando de recebimento do peso";
			this->ckReqPeso->UseVisualStyleBackColor = true;
			// 
			// label16
			// 
			this->label16->Location = System::Drawing::Point(6, 177);
			this->label16->Name = L"label16";
			this->label16->Size = System::Drawing::Size(87, 26);
			this->label16->TabIndex = 3;
			this->label16->Text = L"Posio  inicial do peso";
			// 
			// label15
			// 
			this->label15->Location = System::Drawing::Point(6, 102);
			this->label15->Name = L"label15";
			this->label15->Size = System::Drawing::Size(86, 26);
			this->label15->TabIndex = 2;
			this->label15->Text = L"Qtd de digitos do peso";
			// 
			// label14
			// 
			this->label14->Location = System::Drawing::Point(6, 76);
			this->label14->Name = L"label14";
			this->label14->Size = System::Drawing::Size(59, 15);
			this->label14->TabIndex = 1;
			this->label14->Text = L"Porta COM";
			// 
			// label7
			// 
			this->label7->Location = System::Drawing::Point(6, 31);
			this->label7->Name = L"label7";
			this->label7->Size = System::Drawing::Size(100, 26);
			this->label7->TabIndex = 0;
			this->label7->Text = L"Comando de Solicitao de peso";
			// 
			// menuStrip1
			// 
			this->menuStrip1->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(2) {this->iniciarToolStripMenuItem, 
				this->sairToolStripMenuItem});
			this->menuStrip1->Location = System::Drawing::Point(0, 0);
			this->menuStrip1->Name = L"menuStrip1";
			this->menuStrip1->Size = System::Drawing::Size(653, 24);
			this->menuStrip1->Stretch = false;
			this->menuStrip1->TabIndex = 2;
			this->menuStrip1->Text = L"menuStrip1";
			// 
			// iniciarToolStripMenuItem
			// 
			this->iniciarToolStripMenuItem->Enabled = false;
			this->iniciarToolStripMenuItem->Name = L"iniciarToolStripMenuItem";
			this->iniciarToolStripMenuItem->Size = System::Drawing::Size(51, 20);
			this->iniciarToolStripMenuItem->Text = L"Iniciar";
			this->iniciarToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::iniciarToolStripMenuItem_Click);
			// 
			// sairToolStripMenuItem
			// 
			this->sairToolStripMenuItem->Name = L"sairToolStripMenuItem";
			this->sairToolStripMenuItem->Size = System::Drawing::Size(38, 20);
			this->sairToolStripMenuItem->Text = L"Sair";
			this->sairToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::sairToolStripMenuItem_Click);
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->label1->Location = System::Drawing::Point(13, 329);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(96, 13);
			this->label1->TabIndex = 3;
			this->label1->Text = L"IPs Conectados";
			// 
			// VConectados
			// 
			this->VConectados->FormattingEnabled = true;
			this->VConectados->Location = System::Drawing::Point(12, 345);
			this->VConectados->Name = L"VConectados";
			this->VConectados->Size = System::Drawing::Size(338, 147);
			this->VConectados->TabIndex = 4;
			// 
			// txgateway
			// 
			this->txgateway->Controls->Add(this->listBox1);
			this->txgateway->Location = System::Drawing::Point(360, 39);
			this->txgateway->Name = L"txgateway";
			this->txgateway->Size = System::Drawing::Size(289, 469);
			this->txgateway->TabIndex = 5;
			this->txgateway->TabStop = false;
			this->txgateway->Text = L"Produtos";
			// 
			// listBox1
			// 
			this->listBox1->FormattingEnabled = true;
			this->listBox1->Location = System::Drawing::Point(12, 20);
			this->listBox1->Name = L"listBox1";
			this->listBox1->Size = System::Drawing::Size(268, 433);
			this->listBox1->TabIndex = 1;
			// 
			// lbInform
			// 
			this->lbInform->AutoSize = true;
			this->lbInform->Font = (gcnew System::Drawing::Font(L"Times New Roman", 9.75F, static_cast<System::Drawing::FontStyle>((System::Drawing::FontStyle::Bold | System::Drawing::FontStyle::Italic)), 
				System::Drawing::GraphicsUnit::Point, static_cast<System::Byte>(0)));
			this->lbInform->ForeColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(192)), static_cast<System::Int32>(static_cast<System::Byte>(0)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			this->lbInform->Location = System::Drawing::Point(9, 27);
			this->lbInform->Name = L"lbInform";
			this->lbInform->Size = System::Drawing::Size(0, 16);
			this->lbInform->TabIndex = 6;
			// 
			// timer1
			// 
			this->timer1->Interval = 50;
			this->timer1->Tick += gcnew System::EventHandler(this, &Form1::timer1_Tick);
			// 
			// timerConec
			// 
			this->timerConec->Interval = 1000;
			this->timerConec->Tick += gcnew System::EventHandler(this, &Form1::timerConec_Tick);
			// 
			// oleDbCommand1
			// 
			this->oleDbCommand1->Connection = this->oleDbConnection1;
			// 
			// timerEvento
			// 
			this->timerEvento->Interval = 200;
			this->timerEvento->Tick += gcnew System::EventHandler(this, &Form1::timerEvento_Tick);
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(653, 516);
			this->Controls->Add(this->lbInform);
			this->Controls->Add(this->txgateway);
			this->Controls->Add(this->VConectados);
			this->Controls->Add(this->label1);
			this->Controls->Add(this->tabControl1);
			this->Controls->Add(this->menuStrip1);
			this->Icon = (cli::safe_cast<System::Drawing::Icon^  >(resources->GetObject(L"$this.Icon")));
			this->MainMenuStrip = this->menuStrip1;
			this->Name = L"Form1";
			this->Text = L"SMTGeR...Servidor de Microterminais Gertec - Restaurante";
			this->Load += gcnew System::EventHandler(this, &Form1::Form1_Load);
			this->tabControl1->ResumeLayout(false);
			this->tabPage1->ResumeLayout(false);
			this->tabPage1->PerformLayout();
			this->tabPage2->ResumeLayout(false);
			this->groupBox2->ResumeLayout(false);
			this->groupBox2->PerformLayout();
			this->tabPage3->ResumeLayout(false);
			this->tabPage3->PerformLayout();
			this->groupBox4->ResumeLayout(false);
			this->groupBox4->PerformLayout();
			this->groupBox3->ResumeLayout(false);
			this->groupBox3->PerformLayout();
			this->menuStrip1->ResumeLayout(false);
			this->menuStrip1->PerformLayout();
			this->txgateway->ResumeLayout(false);
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion

//Funo Global para utilizao nas consultas no banco de dados
OleDbDataReader ^sqlReader;
String ^valor;


	/********************************************************************************************************
	* Funo: Funcao																						*
	*********************************************************************************************************
	*																										*
	* Data de Criao: 16/07/2008																			*
	*																										*
	* Descrio: Declarao da DLL, utiliza GetProcAddress para recebimento da mesma 						*	
	*																										*
	*********************************************************************************************************/
	public: Void Funcao (void){
		LPCSTR x = (LPCSTR) "pmtg.dll";
		Hpmtg =  LoadLibraryA(x);

		//Associando os ponteiros s funes da dll instanciada atravs de Hpmgt
		if (Hpmtg != NULL){
			pfun_mt_startserver =	( int (_stdcall *) ( HANDLE hWindow, int conecmsg, int commumsg) )
	  									GetProcAddress ( Hpmtg, "mt_startserver");
			pfun_mt_finishserver =	(void(_stdcall *)())
										GetProcAddress ( Hpmtg, "mt_finishserver");
			pfun_mt_getkey	=		( int (_stdcall *)( int ID, char *buf)) 
										GetProcAddress ( Hpmtg, "mt_getkey");
			pfun_mt_setenablekey =	( int (_stdcall *) ( int ID, BOOL value) )
										GetProcAddress ( Hpmtg, "mt_setenablekey");
 			pfun_mt_dispstr =		( int (_stdcall *)(int Id, char *str))
										GetProcAddress(Hpmtg, "mt_dispstr");
			pfun_mt_dispch =		( int (_stdcall *)(int ID, char ch ))
										GetProcAddress ( Hpmtg, "mt_dispch");
			pfun_mt_connectlist =	( TTABSOCK (_stdcall *)())
										GetProcAddress (Hpmtg, "mt_connectlist");
			pfun_mt_formfeed =		( int (_stdcall *)(int Id))
										GetProcAddress (Hpmtg, "mt_formfeed");
			pfun_mt_linefeed =		( int (_stdcall *)(int ID))
										GetProcAddress (Hpmtg, "mt_linefeed");
			pfun_mt_carret =		( int (_stdcall *)(int ID))
										GetProcAddress (Hpmtg, "mt_carret");
			pfun_mt_gotoxy =		( int (_stdcall *)(int ID, int lin, int col))
										GetProcAddress (Hpmtg, "mt_gotoxy");
			pfun_mt_inet_ntoa_inv = ( char *(_stdcall *)(DWORD oip))
										GetProcAddress (Hpmtg, "mt_inet_ntoa_inv");
			pfun_mt_reqconfigserial=( int (_stdcall *)(int ID, BYTE COM))
										GetProcAddress (Hpmtg, "mt_reqconfigserial");
			pfun_mt_sendconfigserial=( int (_stdcall *)(int ID, ARG_COM_SETUPSERIAL *config))
										GetProcAddress (Hpmtg, "mt_sendconfigserial");
			pfun_mt_getconfigserial=( int (_stdcall *)(int ID,  ARG_COM_SETUPSERIAL *config))
										GetProcAddress (Hpmtg, "mt_getconfigserial");
			pfun_mt_restart =		( int (_stdcall *)(int ID) )
										GetProcAddress (Hpmtg,  "mt_restart");
			pfun_mt_setenableserial =( int (_stdcall *) (int ID, BYTE COM, int OnOff))
										GetProcAddress (Hpmtg, "mt_setenableserial");
			pfun_mt_sendbinserial = ( int (_stdcall *)(int ID, BYTE COM, LPBYTE Bin, BYTE tam))
										GetProcAddress (Hpmtg, "mt_sendbinserial" );
			pfun_mt_getserial =		(int (_stdcall * )(int ID, int *sercomp, char *buf))
										GetProcAddress (Hpmtg, "mt_getserial");
			pfun_mt_getexconfig =	(int (_stdcall * )(int ID, TExSetupTCP* config))
										GetProcAddress (Hpmtg, "mt_getexconfig");
			pfun_mt_reqexconfig	=	(int (_stdcall * )(int ID))
										GetProcAddress (Hpmtg, "mt_reqexconfig");

		}

	}


	/********************************************************************************************************
	* Funo: iniciarToolStripMenuItem_Click																*
	*********************************************************************************************************
	*																										*
	* Data de Criao: 07/07/2008																			*
	*																										*
	* Descrio: Boto responsvel pela iniciao da DLL e conexo dos										*	
	*  		     microterminais. Utiliza a funo mt_startserver.											*
	*																										*
	*********************************************************************************************************/
	private: System::Void iniciarToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
		HANDLE hWindow;
		//Efetua a abertura da DLL
		if (iniciarToolStripMenuItem->Text == "Iniciar"){
			if (Conecta()== 1){
				Funcao();
				if (pfun_mt_startserver	(hWindow,CONNECT_MSG,COMUNICATION_MSG)> 0) {
					lbInform->Text = "";
					iniciarToolStripMenuItem->Text = "Terminar";

					timerConec->Enabled = true;

					bdAccess->Enabled =false;
					bdSql->Enabled = false;

					label2->Enabled = false;
					label3->Enabled = false;
					label4->Enabled = false;
					label5->Enabled = false;
					txServidor->Enabled = false;
					txBanco->Enabled = false;
					txUser->Enabled = false;
					txPass->Enabled = false;

					label6->Enabled = false;
					label18->Enabled = false;
					txbancoac->Enabled = false;
					txway->Enabled = false;
				}else{
					lbInform->Text = "Falha ao iniciar servidor"; 
				}	
			}
		}else{
			pfun_mt_finishserver();
			bdAccess->Enabled =true;
			bdSql->Enabled = true;
			iniciarToolStripMenuItem->Text = "Iniciar";
			if (bdSql->Checked == true){
				bdSql->Checked = true;
			}else{
				bdAccess->Checked = true;
			}

		}

	}

	/********************************************************************************************************
	* Funo: timerConec_Tick																					*
	*********************************************************************************************************
	*																										*
	* Data de Criao: 14/07/2008																			*
	*																										*
	* Descrio: Responsvel pela conexo dos microterminais											*	
	*																										*
	*********************************************************************************************************/
	private: System::Void timerConec_Tick(System::Object^  sender, System::EventArgs^  e) {
		int i ;
		qconect = 0;
		String^addr;
	    
		//Recebe ID dos terminais conectados.
		tabcon = (pfun_mt_connectlist());
		VConectados->Items->Clear();
		for (i = 0; i <= 255; i++){
			if (tabcon.TabIP[i] != 0){
				qconect = qconect + 1;
				//Inverte o IP recebido
				addr = (InverteIp(pfun_mt_inet_ntoa_inv(tabcon.TabIP[i])));
				VConectados->Items->Add (addr);
				VConectados->SelectedIndex = 0;
			}
		}
		timer1 ->Enabled = true;
	}

	/********************************************************************************************************
	* Funo: InvertIp 																						*
	*********************************************************************************************************
	*																										*
	* Data de Criao: 24/07/2008																			*
	*																										*
	* Retorno: String																						*
	*																										*	
	* Descrio: Responsvel por inverter o IP																*	
	*																										*
	*********************************************************************************************************/
	private:String^InverteIp(char *ip){
		String^iop;
		int a,b,c, id;
		char *CaracterEncontrado;
		//tamanho do ip
		id = strlen(ip);
		//Localiza onde esta o primeiro ponto
		CaracterEncontrado = strchr( ip, '.' );
		a = strlen(CaracterEncontrado);
		//Localiza onde esta o segundo ponto
		CaracterEncontrado = strchr(++CaracterEncontrado, '.' );
		b = strlen(CaracterEncontrado);
		//Localiza onde esta o terceiro ponto
		CaracterEncontrado = strchr(++CaracterEncontrado, '.' );
		c = strlen(CaracterEncontrado);
		//Inverte o ip incluindo em uma string de acordo com as posies						
		iop = (gcnew String(ip))->Substring((id-c)+1,(c-1))+(gcnew String(ip))->Substring((id-b),(b-c))
			 +(gcnew String(ip))->Substring((id-a),(a-b))+"."+(gcnew String(ip))->Substring(0,(id-a));
		
		return iop;
	}

	
	/********************************************************************************************************
	* Funo: timer1_Tick																					*
	*********************************************************************************************************
	*																										*
	* Data de Criao: 11/07/2008																			*
	*																										*
	* Descrio: Responsvel pelo recebimento e envio de mensagens											*	
	*																										*
	*********************************************************************************************************/
	private:System::Void timer1_Tick(System::Object^  sender, System::EventArgs^  e) {
		char buf [256];
		char msg [256];
		char buf2[2];
		int ptam, k;
		int porta;
		char bufbalanc[256], balanca[256];
		int recSerial;
		float aux;
		recSerial = 0;
		memset(bufbalanc,0,256);
		
		//qconect: corresponde a quantidade de microterminais conectados 
		if (qconect > 0){
			for (qconec =1; qconec <= qconect; qconec++){
				//Recebe as teclas do MT e verifica se  numerico 
				//Caso seja numerico mostra no display
				if (pfun_mt_getkey(qconec, buf)> 0){
					if ((atoi(&buf[0]))||(buf[0]=='0')){
						if (peso[qconec] == 0){
							memset(buf2, 0, 256);
							buf2[0]= buf[0];
							buf2[1] = 0;
							//armazena o que foi digitado na variavel "palavra[qconec]"
							//onde qconec corresponde ao microterminal ativo no momento
							strcat(palavra[qconec], &buf2[0]); 
							pfun_mt_dispch (qconec, buf[0]);
						}
					//Caso tenha apertado a tecla "+" verifica se esta no passo 6 (incluso da qtd do produto)
					// e efetua o peso do produto atraves da balana conectada em determinada porta.
						
					}if ((passo[qconec]==6 )&&(buf[0]== 43)){
						peso[qconec]= 1;  //Prioriza pesagem ao inves de digitao
						memset(palavra[qconec],0,40);
						//Verifica a porta Com
						if (txComBalanca->Text->ToString() == ""){
							porta= 0;
						}else{ 
							porta = (int)(atoi((char*)(void*)Marshal::StringToHGlobalAnsi(txComBalanca->Text))) - 1;
						}
						
						//Verifica o comando de envio para receber o peso da balana
						if (txComanPeso->Text->ToString() == ""){
							recSerial = 05;
						}else{ 
							int digpeso;
							digpeso = (int)atoi((char *)(void*)Marshal::StringToHGlobalAnsi(txComanPeso->Text->ToString()));
							recSerial = digpeso;
						}
						pfun_mt_gotoxy(qconec, 2, 10); //posiciona o cursor
						// Rotina de troca de informao - QTD por PESO
						strcpy (msg,"Peso:      ");
						pfun_mt_dispstr(qconec, msg);
						pfun_mt_gotoxy(qconec, 2, 15);

						pfun_mt_setenableserial(qconec, porta, 1);

						Sleep(50);
					
						// Envia o comando para recebimento do peso
						if (pfun_mt_sendbinserial(qconec, porta, (LPBYTE)&recSerial, 1) <= 0){
							strcpy (msg,"ERRO");
						}
						Sleep(450); // Tempo de espera para atualizao da balana
						memset(palavra[qconec],0,40);
						memset(bufbalanc,0,256);
						if (pfun_mt_getserial(qconec, &porta, bufbalanc)){
							bufbalanc[strlen(bufbalanc)-1] = 0;
							strcpy(balanca, &bufbalanc[2]);
							aux = (float)(atof(balanca))/1000;
							sprintf(balanca,"%.3f", aux);
							strcat(palavra[qconec], balanca);
							pfun_mt_dispstr(qconec, balanca);
						
						}
                
					}else if (buf[0]== 8 ||(buf[0]== 13 || buf[0] == 27)){
						/************************************************************
						*   Se a tecla foi Backspace segue o seguinte procedimento	*
						*************************************************************/           
						if (buf[0] == 8) {
							if (peso[qconec] == 0){
								if (strlen(palavra[qconec]) > 0){
									ptam = strlen (palavra[qconec]);
									palavra[qconec][ptam-1] = 0;
									pfun_mt_dispstr (qconec, buf);
								}
							}
						/***********************************************************
						*   Se a tecla foi ENTER segue o seguinte procedimento     *
						************************************************************/              
						// O Enter se responsabilizar pelos passos que ocorem como passagem para proxima tela,
						// confirmao do pedido, incluso de observao, etc...
						}else if (buf[0]==13){
							//Verificao de cancelamento de item
							if (cancela == 1){
								passo[qconec]--;
								memset(palavra[qconec],0,40);
								NumeroProd[qconec]= 1;
								TimerPasso(qconec);								
								cancela = 0;
								break;
							}
							if (peso[qconec] == 1){
								peso[qconec] = 0;
							}
							switch (passo[qconec]){
								case 0:
									passo[qconec] = 1;
									TimerPasso(qconec);
									memset (palavra[qconec], 0,40) ;
									break;
								//{****OPERADOR****}
								case 1:
									if (palavra[qconec][0]== 0){
										TimerPasso (qconec);
										memset(palavra[qconec], 0, 40);										
										
									}else
									//Consulta o codigo do operador
									if (LancamentoUsuario (palavra[qconec], qconec)==1){
										passo[qconec]++;
										TimerPasso(qconec);
										memset(palavra[qconec], 0, 40);
									}else {
										//Caso no tenha um operador envia OPERADOR iNVALIDO!!!
										pfun_mt_formfeed (qconec);
										strcpy (msg,"    OPERADOR");
										pfun_mt_dispstr(qconec, msg);
										
										pfun_mt_linefeed (qconec);
										pfun_mt_carret (qconec);
										strcpy (msg,"    INVALIDO!!!");
										pfun_mt_dispstr( qconec, msg);
										Sleep (1000);
										TimerPasso(qconec);
										memset(palavra[qconec], 0, 40);
									}
									break;
								/***CARTAO***/
								case 2: 
									if (strlen(palavra[qconec]) == 0){
										TimerPasso(qconec);
										memset(palavra[qconec], 0, 40);
									}else{
										//Consulta o codigo do cartao(comanda)
										if (LancamentoCartao (palavra[qconec], qconec)== 1) {
											NumeroProd[qconec]= 1;
											passo[qconec]++;
											TimerPasso(qconec);
											memset(palavra[qconec], 0, 40);
										}else {
											//Caso no tenha um carto vlido envia CARTAO INVALIDO!!!
											pfun_mt_formfeed (qconec);
											strcpy (msg,"     CARTAO");
											pfun_mt_dispstr (qconec, msg);
											Sleep (100);
											pfun_mt_linefeed (qconec);
											pfun_mt_carret (qconec);
											strcpy (msg,"    INVALIDO!!!");
											pfun_mt_dispstr( qconec, msg);
											Sleep (1000);                         
											TimerPasso(qconec);
											memset(palavra[qconec], 0, 40);
										}
									}
									break;
								/***LOCAL***/
								case 3:
									//Consulta do LOCAL (Mesa, etc.) do pedido
									if (strlen(palavra[qconec]) == 0){
										passo[qconec] ++;
										TimerPasso(qconec);
										memset(PedidoG[qconec].Local,0, 10);
										memset(palavra[qconec],0,40);
									} else {
										passo[qconec] ++ ;
										TimerPasso(qconec);
										strcpy(PedidoG[qconec].Local ,palavra[qconec]);
										memset(palavra[qconec],0,40);
									}
									break;
								/***GUIA***/
								case 4:
									//Consulta da Guia (?)
									if (strlen(palavra[qconec]) == 0){
										passo[qconec]++;
										TimerPasso(qconec);
										PedidoG[qconec].Guia.CodGuia = 0;
										memset(PedidoG[qconec].Guia.NomeGuia,0,50);
									} else if (LancamentoGuia(palavra[qconec], qconec)== 1){
										passo[qconec]++;
										TimerPasso (qconec);
										memset(palavra[qconec],0,40);
									} else {
										//Caso no tenha uma guia valida envia GUIA INVALIDA!!!
										pfun_mt_formfeed (qconec);
										strcpy (msg,"     GUIA");
										pfun_mt_dispstr (qconec, msg);
										Sleep(100);

										pfun_mt_linefeed (qconec);  
										pfun_mt_carret (qconec);
										
										strcpy (msg,"  INVALIDA!!!");
										pfun_mt_dispstr( qconec, msg);
										Sleep (1000);
										TimerPasso(qconec);
										memset(palavra[qconec], 0, 40);
									}
									break;
								/***PRODUTOS***/
								case 5:
									/*Variaveis*/
									char print[256][256];
									String ^dados;
									DateTime d;
									float price;
									char sprice[50];
									int tam, j, a, i;

									int aux;

									price = 0;
									a = 10;

									// Primeiramente verifica se o pedido esta sendo finalizado
									// Caso o produto esteja em branco, este indoca que o pedido foi finalizado
									if (strlen(palavra[qconec])== 0){
										j = 0;
										// Finalizao dos pedidos...
										// Se houver pedidos estes so inclusos na lista e finalizado.
										if (NumeroProd[qconec] != 1){
											// Aqui  incluso o cabealho do que ser impresso com uma pequena 
											// inicializao, data e hora do pedido.
											
											// Print - variavel para futura impresso.
											
											// Como o print  do tipo char atribuimos todos os dados a serem impressos
											// e/ou mostrado no listbox na variavel dados (do tipo String)que em seguida e 
											// convertido para o tipo utilizado, assim economizamos nos dados a serem atribuidos
											dados = ("****** Sistema de Restaurante Gertec ******");
											strcat(print[j],(char*)(void*)Marshal::StringToHGlobalAnsi(dados));
											// O contador "j" ser equivalente a linha atual da variavel "print". 
											j++; //Incluimos a proxima linha 
											dados = ("Data e Horario: " + d.Date.Now.ToString());
											strcat(print[j],(char*)(void*)Marshal::StringToHGlobalAnsi(dados));
											listBox1->Items->Add(dados);
											j++;
											
											//Inclui o pedido na lista e no buffer de impressao (print[])
											dados = (PedidoG[qconec].CodUsuario.ToString() + " - " + gcnew String(PedidoG[qconec].Usuario));
											listBox1->Items->Add(dados);
											strcpy(print[j],(char*)(void*)Marshal::StringToHGlobalAnsi(dados));
											j++;
											dados = ("Cartao - " + (PedidoG[qconec].Card.codCartao.ToString()));
											listBox1->Items->Add (dados);
											strcpy(print[j],(char*)(void*)Marshal::StringToHGlobalAnsi(dados));
											j++;
											dados = ("Local - " + gcnew String(PedidoG[qconec].Local));
											listBox1->Items->Add (dados);											
											strcpy(print[j],(char*)(void*)Marshal::StringToHGlobalAnsi(dados)); 
											j++;
											dados = ("Guia - " + PedidoG[qconec].Guia.CodGuia.ToString() + " - " + gcnew String(PedidoG[qconec].Guia.NomeGuia));
											listBox1->Items->Add (dados);
											strcpy(print[j],(char*)(void*)Marshal::StringToHGlobalAnsi(dados));
											j++;

											for ( i = 1; i<= NumeroProd[qconec] - 1 ; i++){
												dados = (PedidoG[qconec].Cesta[i].CodProduto.ToString() + " - " + gcnew String(PedidoG[qconec].Cesta[i].DescricaoProduto) + " x " + PedidoG[qconec].Cesta[i].Quantidade.ToString());						
												listBox1->Items->Add (dados);
							                    strcpy(print[j],(char*)(void*)Marshal::StringToHGlobalAnsi(dados));
									            j ++;
												if( strlen(PedidoG[qconec].Cesta[i].Obs) > 0){
													dados = ("      (" + gcnew String(PedidoG[qconec].Cesta[i].Obs) + ")");
													listBox1->Items->Add (dados);
													strcpy(print[j],(char*)(void*)Marshal::StringToHGlobalAnsi(dados));
													j++;
													memset(PedidoG[qconec].Cesta[i].Obs,0,1024);
												}
												//--------> Inclui o formato moeda
												sprintf(sprice,"R$ %.2f",PedidoG[qconec].Cesta[i].Valor);
												dados = ("Valor Unit: " + gcnew String(sprice) );
												sprintf(sprice,"R$ %.2f",(PedidoG[qconec].Cesta[i].Valor * PedidoG[qconec].Cesta[i].Quantidade));
												dados+= ( " .......Total: " + gcnew String (sprice));
												listBox1->Items->Add (dados);
												strcpy(print[j],(char*)(void*)Marshal::StringToHGlobalAnsi(dados));
												j++;
												// Verifica o total dos pedidos
												PedidoG[qconec].TotalCartao += (PedidoG[qconec].Cesta[i].Valor * PedidoG[qconec].Cesta[i].Quantidade);
												price += (float) (PedidoG[qconec].Cesta[i].Valor * PedidoG[qconec].Cesta[i].Quantidade);
												sprintf(sprice,"R$ %.2f",price);
											}
											dados = ("Total: " + gcnew String(sprice));
											listBox1->Items->Add (dados) ;
											strcpy(print[j],(char*)(void*)Marshal::StringToHGlobalAnsi(dados));
											j++;
											dados = (" - - - - - - - - - - - - - - - - - - - - - - - - ");
											listBox1->Items->Add (dados);
											strcpy(print[j],(char*)(void*)Marshal::StringToHGlobalAnsi(dados));

											//Efetua a gravao do carto
											if (LancamentoGravarDados(PedidoG[qconec].Card.codCartao) == 1){												
												pfun_mt_formfeed (qconec);
												strcpy(msg,"   LANCAMENTO");
												pfun_mt_dispstr(qconec, msg);
												
												pfun_mt_linefeed (qconec);
												pfun_mt_carret(qconec);
												strcpy (msg,"   EFETUADO!!!");
												pfun_mt_dispstr(qconec,msg);
												
												Sleep (1000);
												
												passo[qconec] = 2;     //volta para Carto:
												TimerPasso(qconec);
												memset(palavra[qconec],0,40);
											} else { 
												//Caso ocorrer falha na gravao, esta  informada no display e finaliza o pedido
												pfun_mt_formfeed (qconec);
												strcpy (msg,"   LANCAMENTO");
												pfun_mt_dispstr(qconec, msg);
												
												pfun_mt_linefeed (qconec);
												
												pfun_mt_carret(qconec);      
												strcpy (msg," SEM GRAVACAO!!!");
												pfun_mt_dispstr(qconec, msg);
												
												Sleep (1000);
												
												passo[qconec]= 2;     //volta para Carto:
												TimerPasso(qconec);
												memset(palavra[qconec],0,40);
											}//Finalizao finalizada!!!
											/********************************************************
											*                 ROTINA PARA IMPRESSO                 *
											*********************************************************/
											//Se o boto imprimir estiver ativo segue a rotina
											if (OpImp->Checked == true){
												//Verifica a porta indicada a impressora
												if (txComImp->Text== ""){
													porta = 0  ;
												}else {
													porta = atoi((char*)(void*)Marshal::StringToHGlobalAnsi(txComImp->Text->ToString()))- 1;
													pfun_mt_setenableserial (qconec, porta, 1);//Habilita a serial
													for (k =0; k <= j; k++){
														//Se tiver mais de 256 caracteres a string deve ser dividida
														//pois acima de 256 ir travar
														tam = strlen(print[k]);
														if (tam > 256){
															//**continua:
continua:
															memset (buf, 0, 256); // Zera o buffer
															if (k < tam){
																memset (buf, 0, 256); // Zera o buffer
																//Inclui a informao a ser impressa no Buffer
																strcpy(buf, print[k]);
															}
															//Imprime
															pfun_mt_sendbinserial(qconec,porta,(LPBYTE)&buf, 255);
															Sleep(100); // Tempo de ociosidade do microterminal
															k = k + 255; // aumenta no contador a quantidade de caracter j impresso (256)
															tam = tam - 256;//Diminui do tamanho os 256 caracteres j impresso
															//Verifica novamente se o buffer  maior que 256
															if ((k < tam )&&(tam > 256)){
																goto continua;
															}else{
																memset (buf, 0, 256); // Zera o buffer
																strcpy(buf,(char*)(void*)Marshal::StringToHGlobalAnsi(print[k][0].ToString()->Substring(k,255)));
																pfun_mt_sendbinserial(qconec,porta,(LPBYTE)&buf, 255);
																Sleep(100);
																//Se finalizou pula uma linha para descarregar o buffer
																pfun_mt_sendbinserial(qconec,porta,(LPBYTE)&a, 2);
															}
														}else {
															memset (buf, 0, 256); // Zera o buffer
															// Envio de menos de 256 bytes...
															// Armazenamos cada caracter da string no vetor Buffer
															strcpy(buf, print[k]);
															// Enviar para a serial linha por linha...
															pfun_mt_sendbinserial (qconec, porta,(LPBYTE)&buf, tam );
															Sleep(100);
															// Pula para a linha de baixo (se a ultima linha enviada no possuir tamanho suficiente para
															// preencher uma linha completa da impressora esta no  impressa, por isso  enviado o comando
															// abaixo para pular para linha debaixo descarregando o que h no buffer)
															pfun_mt_sendbinserial (qconec, porta ,(LPBYTE)&a, 2);
														}
													}
													//Insere espaos para subir o papel na impressora
													pfun_mt_sendbinserial(qconec,porta,(LPBYTE)&a, 2);
													Sleep(100);
													pfun_mt_sendbinserial(qconec,porta,(LPBYTE)&a, 2);
													Sleep(100);
													pfun_mt_sendbinserial(qconec,porta,(LPBYTE)&a, 2);
													Sleep(100);
													pfun_mt_sendbinserial(qconec,porta,(LPBYTE)&a, 2);
													Sleep(100);
												}
											}
											/*************************************************************
											*           Fim da Rotina de Impressao                       *
											**************************************************************/

										// Se NumeroProd estiver vazio o pedido no  finalizado e a tela permanece aguardando
										// a incluso de um produto
										}else{
											TimerPasso(qconec);
											memset(palavra[qconec],0,40);
										}
									}else{
										//Caso no seja finalizao dos pedidos efetua a consulta do cdigo digitado
										if (LancamentoProduto(palavra[qconec], NumeroProd[qconec], qconec ) == 1){
											passo[qconec]++;
											TimerPasso(qconec);
											memset(palavra[qconec],0,40);
										}else{
											TimerPasso(qconec);
											memset(palavra[qconec],0,40);
										}
									}
									break;
								/*PRODUTO: Incluso da quantidade no banco*/
								case 6:
									if (strlen(palavra[qconec])== 0){
										passo[qconec]++;
										TimerPasso(qconec);
										memset(palavra[qconec],0,40);
									}else if (LancamentoProdutoCesta((float)atof(palavra[qconec]), NumeroProd[qconec], qconec) ==1){
										NumeroProd[qconec]++;
										passo[qconec]--;
										TimerPasso(qconec);
										memset(palavra[qconec],0,40);
									} 
									break;
								/****OBSERVAO****/
								case 7:
									if (strlen(palavra[qconec])== 0){
										passo[qconec]-- ;
										TimerPasso(qconec);
										memset(palavra[qconec],0,40);
									} else
									// Se a observao existir efetua mostra no display e inclui no pedido
									if (LancamentoObservacao(atoi(palavra[qconec]), NumeroProd[qconec],qconec) == 1){
										pfun_mt_linefeed (qconec);
										pfun_mt_carret(qconec);
										strcpy (msg, PedidoG[qconec].Cesta[NumeroProd[qconec]].Observ);
										pfun_mt_dispstr(qconec, msg);
										passo[qconec]++;
										memset(palavra[qconec],0,40);
									}else{
										//Se a observao no existir limpa a string palavra
										TimerPasso(qconec);
										memset(palavra[qconec],0,40);
									}
									break;
								/****OBSERVAO****/
								case 8:
									String ^Observa;
									if (strlen(PedidoG[qconec].Cesta[NumeroProd[qconec]].Obs)== 0){
										strcpy(PedidoG[qconec].Cesta[NumeroProd[qconec]].Obs, PedidoG[qconec].Cesta[NumeroProd[qconec]].Observ);
										passo[qconec]--;
										TimerPasso(qconec);
										memset(palavra[qconec],0,40);
									}else{
										Observa = gcnew String(PedidoG[qconec].Cesta[NumeroProd[qconec]].Obs) + "+" + gcnew String(PedidoG[qconec].Cesta[NumeroProd[qconec]].Observ);
										strcpy(PedidoG[qconec].Cesta[NumeroProd[qconec]].Obs ,(char*)(void*)Marshal::StringToHGlobalAnsi(Observa));
										passo[qconec]--;
										TimerPasso(qconec);
										memset(palavra[qconec],0,40);
									}
									break;
							}
						}
						/*********************************************************
						*  Se a tecla for ESC segue o seguinte procedimento      *
						**********************************************************/
						// Caso seja pressionado a tecla ESC retorna para o menu anterior 
						// "cancelando" o que foi escolhido.
						else if (buf[0] = 27){
							//Anula o peso
							peso[qconec]= 0;
							recSerial = 0;
							TimerPasso(qconec);
							memset(palavra[qconec],0,40);
							if (cancela==1){
								TimerPasso(qconec);
								cancela = 0;
							}else{
								
								switch(passo[qconec]){
									// Abaixo  subtraido um passo, indicando que deve retornar ao passo anterior
									// mostrando a tela anterior ou a mesma tela porem limpa.
									case 1:
										TimerPasso(qconec);
										break;
									case 2: 
										passo[qconec]--;
										TimerPasso(qconec);
										break;								
									case 3:
										passo[qconec]--;
										TimerPasso(qconec);
										break;
									case 4: 
										passo[qconec]--;
										TimerPasso(qconec);							
										break;
									case 5:
										//Confirmar cancelamento do pedido
										if (NumeroProd[qconec]!=1){
											pfun_mt_formfeed (qconec);
											strcpy(msg,"ENTER-Cancela Pedido");
											pfun_mt_dispstr(qconec, msg);
											
											pfun_mt_linefeed (qconec);
											pfun_mt_carret(qconec);
											strcpy (msg,"ESC  - Voltar");
											pfun_mt_dispstr(qconec,msg);
											
											Sleep (1000);
											cancela = 1;
										}else{
											passo[qconec]--;
											TimerPasso(qconec);
										}
										break;
									case 6: 
										passo[qconec]--;
										TimerPasso(qconec);
										break;
									case 7:
										passo[qconec]--;
										TimerPasso(qconec);
										break;
									case 8:
										passo[qconec]--;
										TimerPasso(qconec);
										break;
									case 20:
										passo[qconec]= 21;
										TimerPasso(qconec);
										break;
								}
							}
						}
					}
				}
			
				/********************************************************************************
				* Caso a balana envie o peso atraves de um boto esta rotina faz o recebimento *
				*********************************************************************************/
				porta = (int)(atoi((char*)(void*)Marshal::StringToHGlobalAnsi(txComBalanca->Text)))-1;	
				if (pfun_mt_getserial(qconec, &porta, bufbalanc) > 0){
					if ((passo[qconec]== 6)&&(ckReqPeso->Checked == true)){
						if (strcmp(bufbalanc,((char * )(void*)Marshal::StringToHGlobalAnsi(txRecPeso->Text)))){
							//Informa que o produto pesado neste momento  prioridade e desabilita a digitao
							peso[qconec] = 1;
							memset(palavra[qconec],0,40); // Limpa o buffer para no incluir algo que foi digitado anteriormente
							pfun_mt_gotoxy (qconec, 2, 10); //posiciona o cursor
							// Rotina de troca de informao - QTD por PESO
							strcpy(msg,"Peso:      ");
							pfun_mt_dispstr(qconec, msg);
							//posiciona o cursor
							pfun_mt_gotoxy (qconec, 2, 15); 
							
							bufbalanc[strlen(bufbalanc)-1] = 0;
							int posicao; //posio onde inicia o peso
							posicao = atoi((char*)(void *)Marshal::StringToHGlobalAnsi(txPosPeso->Text));
							strcpy(balanca, &bufbalanc[posicao]);
							//inclui uma virgula
							aux = (float)(atof(balanca))/1000;
							sprintf(balanca,"%.3f", aux);
							strcat(palavra[qconec], balanca);
							pfun_mt_dispstr(qconec, balanca);							
						}
					}
				}

			}
				
		}
	}

	/********************************************************************************************************
	* Funo: TimerPasso																					*
	*********************************************************************************************************
	*																										*
	* Data de Criao: 16/07/2008																			*
	*																										*
	* Descrio: Responsvel pela fases no microterminais e envio das telas									*	
	*																										*
	*********************************************************************************************************/
	private: Void TimerPasso (int IP){
		 char MsgStr[256]; 
		 
		 /* switch (passo[IP])...: Verifica em qual fase o microterminal esta e mostra 
		  * a proxima tela ou a tela anterior */
		 switch (passo[IP]){
			 case 0:
				 passo[IP]++;
				 break;
			 case 1:
				 pfun_mt_formfeed(IP);
				 //Envia a 1 tela ao terminal (Operador)
				 strcpy (MsgStr,"Operador:");
				 pfun_mt_dispstr(IP,MsgStr);
				 Sleep (1000);
				 break;
			 case 2:
				 pfun_mt_formfeed(IP);
				 strcpy (MsgStr, "Cartao:");
				 pfun_mt_dispstr(IP, MsgStr);
				 Sleep (1000);
				 break;
			 case 3:
				 pfun_mt_formfeed (IP);
				 //Envia a 3 tela ao terminal (Local)
				 strcpy (MsgStr, "Local:");
				 pfun_mt_dispstr (IP, MsgStr);
				 Sleep (1000);
				 break;
			 case 4:
				 pfun_mt_formfeed (IP);
				 //Envia a 4 tela ao terminal (Guia)
				 strcpy (MsgStr, "Guia:");
				 pfun_mt_dispstr (IP, MsgStr);
				 Sleep (1000);
				 break;
			 case 5:
				 pfun_mt_formfeed (IP);
				 //Envia a 5 tela ao terminal (Produto)
				 strcpy (MsgStr, "Produto:");
				 pfun_mt_dispstr (IP, MsgStr);
				 Sleep (1000);
				 break;
			 case 6:
				 // Envia a tela de pedido
				 // Enviando a 1 linha com a descrio do produto pedido
				 pfun_mt_formfeed(IP);
				 strcpy (MsgStr, PedidoG[IP].Cesta[NumeroProd[IP]].DescricaoProduto);
				 pfun_mt_dispstr(IP, MsgStr);

				 // Enviando a 2 linha com o valor do produto pedido
				 pfun_mt_linefeed (IP);
				 pfun_mt_carret (IP);
				 sprintf(MsgStr,"R$ %.2f",PedidoG[qconec].Cesta[NumeroProd[IP]].Valor);
				 pfun_mt_dispstr (IP, MsgStr);
				 
				 // Incluindo o local de digitao de Qtd posicionando o cursor
				 pfun_mt_gotoxy (IP, 2, 10);
				 strcpy (MsgStr, "Qtd:");
				 pfun_mt_dispstr (IP, MsgStr);
				 Sleep (1000);
				 break;
			 case 7:
				 //Envia a tela de observao
				 pfun_mt_formfeed (IP);
				 strcpy (MsgStr, "Observacao:");
				 pfun_mt_dispstr (IP, MsgStr);
				 Sleep (1000);
				 break;
		 }
	}

	/********************************************************************************************************
	* Funo: Conecta																						*
	*********************************************************************************************************
	*																										*
	* Data de Criao: 17/07/2008																			*
	*																										*
	* Retorno: BYTE																							*
	*																										*
	* Descrio: Responsavel pela conexo com o banco de dados												*	
	*																										*
	*********************************************************************************************************/
	private: BYTE Conecta (void){
		String ^Servidor, ^Banco, ^UId, ^PWD;
		try{

			if (bdAccess->Checked == 1){
				oleDbConnection1->ConnectionString = ("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + txway->Text + "\\" + txbancoac->Text + ";");
				oleDbConnection1->Open();
				oleDbConnection1->Close();
			} else if(bdSql->Checked == 1){
				Servidor = txServidor->Text->ToString();
				Banco = txBanco->Text->ToString();
				UId = txUser->Text->ToString();
				PWD = txPass->Text->ToString();

				if ((UId->Empty) ||(PWD->Empty)){

					oleDbConnection1->ConnectionString = ("Provider=sqloledb;Data Source=" + Servidor + "; Initial Catalog=" + Banco + ";Integrated Security=SSPI;");
					oleDbConnection1->Open();
					oleDbConnection1->Close();
				}else{
					oleDbConnection1->ConnectionString = ("Provider=SQLOLEDB; Data Source= " + Servidor + "; Initial Catalog=" + Banco + ";User Id= " + UId + "; Password= " + PWD + ";");
					oleDbConnection1->Open();
					oleDbConnection1->Close();
				
				}

			}
			return 1;
		}catch(...){
			return 0;
		}
		
	 }


	/********************************************************************************************************
	* Funo: LancamentoUsuario																				*
	*********************************************************************************************************
	*																										*
	* Data de Criao: 18/07/2008																			*
	*																										*
	* Retorno: BYTE																							*
	*																										*	
	* Descrio: Responsvel pela consulta na tabela tabUsuario												*	
	*																										*
	*********************************************************************************************************/
	private: BYTE LancamentoUsuario(char CodUsuario[10], int id){
		try{
			 oleDbConnection1->Open();
			 String ^sQueryString = ("SELECT usuID,usuNome,funID,usuLogin FROM tabUsuario WHERE usuID = " + gcnew String (CodUsuario));
			 oleDbCommand1->CommandText =(sQueryString);
			 sqlReader = oleDbCommand1->ExecuteReader();
			 while (sqlReader->Read()){
				 //Verifica se foi encontrado algum registro
				 if (sqlReader->GetString(1)->ToString() != " "){
						PedidoG[id].CodUsuario = atoi((char*)(void*)Marshal::StringToHGlobalAnsi(sqlReader["usuID"]->ToString()));
						strcpy (PedidoG[id].Usuario,((char *)(void*)Marshal::StringToHGlobalAnsi(sqlReader["usuNome"]->ToString())));
						PedidoG[id].FuncaoID = atoi((char*)(void*)Marshal::StringToHGlobalAnsi(sqlReader["funID"]->ToString()));
						//A funo 5 e 6 indicam que o operador  garom e pode procedir com o pedido
						if ((PedidoG[id].FuncaoID == 5) || (PedidoG[id].FuncaoID == 6)){
							sqlReader->Close();
							oleDbConnection1->Close();	  
							return (1);
						}else{
							sqlReader->Close();
							oleDbConnection1->Close();	
							return (0);
						}
				 }else{
					 sqlReader->Close();
					 oleDbConnection1->Close();	
					 return (0);
				 }
			 }
			 sqlReader->Close();
			 oleDbConnection1->Close();	
			
		 }catch(...){
			 return 0;
		 }
		return 0;
	}

	/********************************************************************************************************
	* Funo: LancamentoCartao																	*
	*********************************************************************************************************
	*																										*
	* Data de Criao: 08/08/2008																			*
	*																										*
	* Retorno: BYTE																							*
	*																										*	
	* Descrio: Responsvel pela consulta na tabela tabCartao												*	
	*																										*
	*********************************************************************************************************/
	private: BYTE LancamentoCartao(char CodCartao[10], int id){
		try{
			 oleDbConnection1->Open();
			 String ^sQueryString = ("SELECT carId, carStatus, carIngresso, carConsumacao, carDesconto, carTxServico "
									+ "FROM tabCartao WHERE carId = " + gcnew String (CodCartao));
			 oleDbCommand1->CommandText =(sQueryString);
			 sqlReader = oleDbCommand1->ExecuteReader();
			 
			 while (sqlReader->Read()){
				 //Verifica se foi encontrado algum registro
				 if (sqlReader->GetString(1)->ToString() != " "){
					 PedidoG[id].Card.codCartao  = atoi((char*)(void*)Marshal::StringToHGlobalAnsi(sqlReader["carId"]->ToString()));
					 strcpy(PedidoG[id].Card.StatusCartao,((char*)(void*)Marshal::StringToHGlobalAnsi(sqlReader["carStatus"]->ToString())));
					 PedidoG[id].Card.txConsumacao = atoi((char*)(void*)Marshal::StringToHGlobalAnsi(sqlReader["carConsumacao"]->ToString()));
					 PedidoG[id].Card.txServico = atoi((char*)(void*)Marshal::StringToHGlobalAnsi(sqlReader["carTxServico"]->ToString()));
					 // Verifica se o Status do carto esta disponivel
					 if ((PedidoG[id].Card.StatusCartao[0] =='U' )||(PedidoG[id].Card.StatusCartao[0] == 'D')){
						 sqlReader->Close();
						 oleDbConnection1->Close();	  
						 return (1);
					 }else{
						 sqlReader->Close();
						 oleDbConnection1->Close();	
						 return (0);
  					 }
				 }else{
					 sqlReader->Close();
					 oleDbConnection1->Close();	
					 return (0);
				 }
			 }
			 sqlReader->Close();
			 oleDbConnection1->Close();	
			
		 }catch(...){
			 return 0;
		 }
		return 0;
	}

 	/********************************************************************************************************
	* Funo: LancamentoGuia																				*
	*********************************************************************************************************
	*																										*
	* Data de Criao: 11/08/2008																			*
	*																										*
	* Retorno: BYTE																							*
	*																										*	
	* Descrio: Responsvel pela consulta da guia na tabela tabUsuario												*	
	*																										*
	*********************************************************************************************************/
	private: BYTE LancamentoGuia(char CodGuia[10], int id){
		try{
			oleDbConnection1->Open();
			String ^sQueryString = ("SELECT usuId,usuNome FROM TabUsuario WHERE usuId = " + gcnew String(CodGuia )+ " AND funId = 4");
			oleDbCommand1->CommandText =(sQueryString);
			sqlReader = oleDbCommand1->ExecuteReader();
			 
			while (sqlReader->Read()){
				//Verifica se foi encontrado algum registro
				if (sqlReader->GetString(1)->ToString() != " "){
					PedidoG[id].Guia.CodGuia = atoi((char*)(void*)Marshal::StringToHGlobalAnsi(sqlReader["usuId"]->ToString()));
					strcpy(PedidoG[id].Guia.NomeGuia , (char*)(void*)Marshal::StringToHGlobalAnsi(sqlReader["usuNome"]->ToString()));
					sqlReader->Close();
					oleDbConnection1->Close();	  
					return (1);
				}else{
					sqlReader->Close();
					oleDbConnection1->Close();	
					return (0);
				}
				
			}
			sqlReader->Close();
			oleDbConnection1->Close();	
			
		}catch(...){
			return 0;
		}
		return 0;
	}


	/********************************************************************************************************
	* Funo: LancamentoGravarDados																				*
	*********************************************************************************************************
	*																										*
	* Data de Criao: 11/08/2008																			*
	*																										*
	* Retorno: BYTE																							*
	*																										*	
	* Descrio: Responsvel pela gravao dos dados do carto												*	
	*																										*
	*********************************************************************************************************/
	private: BYTE LancamentoGravarDados(int Cartao){
	    try{
			String ^sQueryString = ("SELECT mheId From TabHeaderMovimento where carId = " + Cartao.ToString()+ " And mheStatus = '1'");
			oleDbConnection1->Open();
			oleDbCommand1->CommandText =(sQueryString);
			sqlReader = oleDbCommand1->ExecuteReader();
			while (sqlReader->Read()){
				sqlReader->Close();
				oleDbConnection1->Close();	  
				return (1);
			 }
			 sqlReader->Close();
			 oleDbConnection1->Close();	
			
		 }catch(...){
			 return 0;
		 }
		return 0;
	}

	/********************************************************************************************************
	* Funo: LancamentoProduto																				*
	*********************************************************************************************************
	*																										*
	* Data de Criao: 12/08/2008																			*
	*																										*
	* Retorno: BYTE																							*
	*																										*	
	* Descrio: Responsvel pela consulta dos produtos na tabela tab												*	
	*																										*
	*********************************************************************************************************/
	private: BYTE LancamentoProduto(char Produto[50],int NumeroProdutos, int id){
		try{
			 oleDbConnection1->Open();
			 String ^sQueryString = ("SELECT proId,proDescricao,proPreco FROM tabProduto WHERE proId = " + gcnew String (Produto));
			 oleDbCommand1->CommandText =(sQueryString);
			 sqlReader = oleDbCommand1->ExecuteReader();
			 while (sqlReader->Read()){
				 //Verifica se foi encontrado algum registro
				 if (sqlReader->GetString(1)->ToString() != " "){
					 PedidoG[id].Cesta[NumeroProdutos].CodProduto = atoi((char*)(void*)Marshal::StringToHGlobalAnsi(sqlReader["proID"]->ToString()));
					 strcpy (PedidoG[id].Cesta[NumeroProdutos].DescricaoProduto,((char *)(void*)Marshal::StringToHGlobalAnsi(sqlReader["proDescricao"]->ToString())));
					 valor =(sqlReader["proPreco"]->ToString());
					 valor = valor->Replace(',','.');
					 PedidoG[id].Cesta[NumeroProdutos].Valor =(float)( atof((char*)(void*)Marshal::StringToHGlobalAnsi(valor)));
					 sqlReader->Close();
					 oleDbConnection1->Close();	
					 return (1);
				 }else{
					 sqlReader->Close();
					 oleDbConnection1->Close();	
					 return (0);
				 }
			 }
			 sqlReader->Close();
			 oleDbConnection1->Close();	
			
		 }catch(...){
			 return 0;
		 }
		return 0;
	}

	/********************************************************************************************************
	* Funo: LancamentoProdutoCesta																		*
	*********************************************************************************************************
	*																										*
	* Data de Criao: 12/08/2008																			*
	*																										*
	* Retorno: BYTE																							*
	*																										*	
	* Descrio: Responsvel pelo lanamento dos produtos ao pedido 										*	
	*																										*
	*********************************************************************************************************/
	private: BYTE LancamentoProdutoCesta(float Quantidade,int NumeroProduto, int id){
		try{
			//Verifica a quantidade
			if (Quantidade != 0){
				PedidoG[id].Cesta[NumeroProduto].Quantidade = Quantidade;
				return (1);
			}else{
				return (0);
			}
		 }catch(...){
			 return 0;
		 }
	}

	/********************************************************************************************************
	* Funo: LancamentoObservacao																			*
	*********************************************************************************************************
	*																										*
	* Data de Criao: 12/08/2008																			*
	*																										*
	* Retorno: BYTE																							*
	*																										*	
	* Descrio: Responsvel pela consulta das opes existentes para os produtos. Ex: mal passado.			*	
	*																										*
	*********************************************************************************************************/
	private: BYTE LancamentoObservacao(int CodObs,int NumeroProdutos, int id){
		try{
			 String ^sQueryString = ("SELECT * FROM tabObs WHERE obsId = " + CodObs.ToString());
			 oleDbConnection1->Open();
			 oleDbCommand1->CommandText =(sQueryString);
			 sqlReader = oleDbCommand1->ExecuteReader();
			 while (sqlReader->Read()){
				 //Verifica se foi encontrado algum registro
				 if (sqlReader->GetString(1)->ToString() != " "){
					 strcpy (PedidoG[id].Cesta[NumeroProdutos].Observ,((char *)(void*)Marshal::StringToHGlobalAnsi(sqlReader["obsDescricao"]->ToString())));
					 sqlReader->Close();
					 oleDbConnection1->Close();						
					 return (1);
				 }else{
					 sqlReader->Close();
					 oleDbConnection1->Close();	
					 return (0);
				 }
			 }
			 sqlReader->Close();
			 oleDbConnection1->Close();	
			
		 }catch(...){
			 return 0;
		 }
		return 0;
	}


	/********************************************************************************************************
	* Funo: 	timerEvento																					*
	*********************************************************************************************************
	*																										*
	* Data de Criao: 24/07/2008																			*
	*																										*
	* Retorno: Void																							*
	*																										*	
	* Descrio: Responsvel pelo recebimento dos eventos da dll											*	
	*																										*
	*********************************************************************************************************/
	private: System::Void timerEvento_Tick(System::Object^  sender, System::EventArgs^  e) {
		ARG_COM_SETUPSERIAL configserial;
		TExSetupTCP confEx;
		int id;
		char configuracao[20];
		char buf[256];
			
		char config[256] ;

		//ID do terminal selecionado na lista de terminais conectados
		id = (VConectados->SelectedIndex+1);
		/*if (pfun_mt_getexconfig(id, &confEx) >= 1){
			
			txGatew->Text = gcnew String(pfun_mt_inet_ntoa_inv(confEx.gateway));
			txNameServer->Text = gcnew String(pfun_mt_inet_ntoa_inv(confEx.nameserver));
			txMyName->Text = gcnew String(confEx.myname);
			MessageBox::Show("Ok");
			timerEvento->Enabled = false;
		}else{
			timerEvento->Enabled = false;
		}*/



		if (pfun_mt_getconfigserial(id, &configserial)>=1){
			// Cada combo recebe sua respctiva configurao de serial
			cbBaud->Text = configserial.Setup.baud.ToString(); 
			cbBits->Text = configserial.Setup.bits.ToString()  ;
			if (configserial.Setup.parity == 0){
				cbParidade->Text = "Nenhum";
			}else if (configserial.Setup.parity == 1){
				cbParidade->Text = "Impar";
			}else if (configserial.Setup.parity == 2){
				cbParidade->Text = "Par";
			}else if (configserial.Setup.parity == 3){
				cbParidade->Text = "Marca";
			}else if (configserial.Setup.parity == 4 ){
				cbParidade->Text = "Espao";
			}
			cbStop->Text = configserial.Setup.stops.ToString();

			if (configserial.Setup.handshaking == 0){
				cbHand->Text = "Nenhum";
			}else if (configserial.Setup.handshaking = 1){
				cbHand->Text = "CTS / RTS";
			}
		}
	}

	/********************************************************************************************************
	* Funo: 	btRecebeConfSerial																			*
	*********************************************************************************************************
	*																										*
	* Data de Criao: 24/07/2008																			*
	*																										*
	* Retorno: Void																							*
	*																										*	
	* Descrio: Solicita a configurao serial do terminal 												*	
	*																										*
	*********************************************************************************************************/
	private: System::Void btRecebeConfSerial_Click(System::Object^  sender, System::EventArgs^  e) {
		char com;
		if ((VConectados->SelectedIndex == -1)||(cbPorta->SelectedIndex == -1 )){
			MessageBox::Show("Selecione o terminal e/ou a porta", "Ateno"); 

		}else{
			com = cbPorta->SelectedIndex;
			if (pfun_mt_reqconfigserial(VConectados->SelectedIndex +1,com) < 1){
				MessageBox::Show("Erro no envio do comando", "FALHA"); 

			}else{
				timerEvento->Enabled = true;  
			}

		}
	}

	/********************************************************************************************************
	* Funo: 	btEnviaConfSerial																			*
	*********************************************************************************************************
	*																										*
	* Data de Criao: 24/07/2008																			*
	*																										*
	* Retorno: Void																							*
	*																										*	
	* Descrio: Envia a configurao serial para o terminal 												*	
	*																										*
	*********************************************************************************************************/
	private: System::Void btEnviaConfSerial_Click(System::Object^  sender, System::EventArgs^  e) {
		TSetupSerial config;
		ARG_COM_SETUPSERIAL configuracao;
		char *b;
		try{
			if ((VConectados->SelectedIndex == -1)||(cbPorta->SelectedIndex == -1 )){
				MessageBox::Show("Selecione o terminal e/ou a porta", "Ateno!"); 

			}else{
				// Selecionando a COM
				configuracao.Com = cbPorta->SelectedIndex;
				b = (char*)(void*)Marshal::StringToHGlobalAnsi(cbBaud->Text );
				// Recebendo toda configurao da serial
				 
				config.baud = atol (b);
				b = (char*)(void*)Marshal::StringToHGlobalAnsi(cbBits->Text);
				config.bits = (short) atol (b);
				
				if (cbParidade->Text == "Nenhum") {
					config.parity = 0;
				}else if (cbParidade->Text == "Impar"){
					config.parity = 1;
				}else if (cbParidade->Text == "Par"){
					config.parity = 2;
				}else if (cbParidade->Text == "Marca"){
					config.parity = 3;
				}else if (cbParidade->Text == "Espao"){
					config.parity = 4;
				}
				b = (char*)(void*)Marshal::StringToHGlobalAnsi(cbStop->Text );
				config.stops =(short) atol (b);

				if (cbHand->Text == "Nenhum"){
					config.handshaking = 0;
				}else{
					config.handshaking = 1;
				}
				
				configuracao.Setup = config;
				
				// Envia configurao para o terminal
				if (pfun_mt_sendconfigserial((VConectados->SelectedIndex+1),&configuracao) < 1 ){
					MessageBox::Show("Erro enviando comando.", "Falha");
				}else{
					//Reinicia o microterminal para que o mesmo assuma a nova configurao
					pfun_mt_restart(VConectados->SelectedIndex + 1);
				}

			}
		}catch(...){
			MessageBox::Show("Preencha corretamente os campos.", "Erro");
		}

	}


	private: System::Void checkBox2_CheckedChanged(System::Object^  sender, System::EventArgs^  e) {
		 }

	/********************************************************************************************************
	* Funo: 	btImprimi																					*
	*********************************************************************************************************
	*																										*
	* Data de Criao: 04/08/2008																			*
	*																										*
	* Retorno: Void																							*
	*																										*	
	* Descrio: Imprime toda lista de pedidos feito.														*	
	*																										*
	*********************************************************************************************************/
	private: System::Void btImprimi_Click(System::Object^  sender, System::EventArgs^  e) {
		char com, a;
		char buffer [256];
		int i, tam, k, com1 ;

		//Verifica se h um microterminal selecionado e se a porta da impresso
		//foi determinada.
		if ((VConectados->SelectedIndex == -1)||(txComImp->Text == "" )){
			MessageBox::Show("Selecione o terminal e/ou a porta", "Ateno!"); 

		}else{
			com1 = atoi((char *)(void*)Marshal::StringToHGlobalAnsi(txComImp->Text));
			com = com1 - 1;
			a = 10; // Valor correspondente ao prxima linha da impressora
			// Habilita a serial
			pfun_mt_setenableserial (VConectados->SelectedIndex + 1  , com, 1);
			
			for (k = 0 ;(k <= (listBox1->Items->Count-1));k++){
				// Verifica o tamanho de cada linha da lista que ser impressa. 
				// Caso seja maior que 256 caracteres esta deve ser tratada para enviar 
				// a cada 256, acima disso ocorrer erro.
				try{
					tam = listBox1->Items[k]->ToString()->Length;
					if (tam > 256){
continua:
						memset (buffer, 0, 256); // Zera o buffer
						if (i < tam){
							memset (buffer, 0, 256); // Zera o buffer
							//Inclui a informao a ser impressa no Buffer
							strcpy(buffer, (char *)(void*)Marshal::StringToHGlobalAnsi(listBox1->Items[k]->ToString()->Substring(i, 255)));
						}
						//Imprime
						pfun_mt_sendbinserial((VConectados->SelectedIndex + 1),com,(LPBYTE)&buffer, 255);
						Sleep(100); // Tempo de ociosidade do microterminal
						i = i + 255; // aumenta no contador a quantidade de caracter j impresso (256)
						tam = tam - 256;//Diminui do tamanho os 256 caracteres j impresso
						//Verifica novamente se o buffer  maior que 256
						if ((i < tam )&&(tam > 256)){
							goto continua;
						}else{
							memset (buffer, 0, 256); // Zera o buffer
							strcpy(buffer, (char *)(void*)Marshal::StringToHGlobalAnsi(listBox1->Items[k]->ToString()->Substring(i, tam)));
							pfun_mt_sendbinserial((VConectados->SelectedIndex + 1),com,(LPBYTE)&buffer, 255);
							Sleep(100);
							//Se finalizou pula uma linha para descarregar o buffer
							pfun_mt_sendbinserial((VConectados->SelectedIndex + 1),com,(LPBYTE)&a, 2);
						}
					}else {
						memset (buffer, 0, 256); // Zera o buffer
						// Envio de menos de 256 bytes...
						// Armazenamos cada caracter da string no vetor Buffer
						strcpy(buffer, (char *)(void*)Marshal::StringToHGlobalAnsi(listBox1->Items[k]->ToString()));
                        // Enviar para a serial linha por linha...
						pfun_mt_sendbinserial ((VConectados->SelectedIndex + 1), com,(LPBYTE)&buffer, tam );
						Sleep(100);
						// Pula para a linha de baixo (se a ultima linha enviada no possuir tamanho suficiente para
						// preencher uma linha completa da impressora esta no  impressa, por isso  enviado o comando
						// abaixo para pular para linha debaixo descarregando o que h no buffer)
						pfun_mt_sendbinserial (VConectados->SelectedIndex + 1, com ,(LPBYTE)&a, 2);
					}
					
				}catch (...){
					MessageBox::Show("Falha no envio!", "Erro");
					break;
				}
			
			} 
			// Inclui 4 linhas de espao para subir o papel da impressora e incluir um espao entre esta e 
			// a proxima impresso. Sempre inclui um tempo de 100ms para no encavalar as informaes
			pfun_mt_sendbinserial (VConectados->SelectedIndex + 1, com ,(LPBYTE)&a, 2);
			Sleep(100);
			pfun_mt_sendbinserial (VConectados->SelectedIndex + 1, com ,(LPBYTE)&a, 2);
			Sleep(100);
			pfun_mt_sendbinserial (VConectados->SelectedIndex + 1, com ,(LPBYTE)&a, 2);
			Sleep(100);
			pfun_mt_sendbinserial (VConectados->SelectedIndex + 1, com ,(LPBYTE)&a, 2);
			Sleep (100);
		}
	}

	/********************************************************************************************************
	* Funo: 	sairToolStripMenuItem																		*
	*********************************************************************************************************
	*																										*
	* Data de Criao: 05/08/2008																			*
	*																										*
	* Retorno: Void																							*
	*																										*	
	* Descrio: Menu Sair - responsvel pela saida do programa e fechamento da DLL.						*	
	*																										*
	*********************************************************************************************************/
	private: System::Void sairToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
		if (iniciarToolStripMenuItem->Text == "Terminar"){
			pfun_mt_finishserver ();
		}
		Close();
	}
	/********************************************************************************************************
	* Funo: Form1_Load																					*
	*********************************************************************************************************
	*																										*
	* Data de Criao: 20/08/2008																			*
	*																										*
	* Retorno: Void																							*
	*																										*	
	* Descrio: Responsvel pela iniciao do programa e preenchimento do banco gravado					*	
	*																										*
	*********************************************************************************************************/
	private: System::Void Form1_Load(System::Object^  sender, System::EventArgs^  e) {
		FILE *ArqBanco;
		char retorno[256];

		ArqBanco = fopen((char *)"saveBanco.txt", "r");
		
		if (ArqBanco!= NULL){
			readFileString(ArqBanco,retorno,"gravar","0");
			if (strcmp(retorno,"1")== 0 ){
				//cbGravar->Checked = true;
				readFileString(ArqBanco, retorno,"sqlServidor","");
				txServidor->Text = gcnew String(retorno);
				readFileString(ArqBanco,retorno, "sqlBanco","");
				txBanco->Text = gcnew String(retorno);
				readFileString(ArqBanco,retorno, "sqlUser","");
				txUser->Text = gcnew String(retorno);
				readFileString(ArqBanco,retorno, "sqlPass","");
				txPass->Text = gcnew String(retorno);
				
				readFileString(ArqBanco,retorno, "mdbBanco","");
				txbancoac->Text= gcnew String(retorno);
				readFileString(ArqBanco,retorno, "mdbCaminho","");
				txway->Text = gcnew String(retorno);
			}
			fclose(ArqBanco);
		}
		iniciarToolStripMenuItem->Enabled = false;

	}		 
	/********************************************************************************************************
	* Funo: bdSql																							*
	*********************************************************************************************************
	*																										*
	* Data de Criao: 18/08/2008																			*
	*																										*
	* Retorno: Void																							*
	*																										*	
	* Descrio: Responsvel pela habilitao dos campos referente ao banco de dados						*	
	*																										*
	*********************************************************************************************************/
	private: System::Void bdSql_CheckedChanged(System::Object^  sender, System::EventArgs^  e) {
		if (bdSql->Checked == true){
			label2->Enabled = true;
			label3->Enabled = true;
			label4->Enabled = true;
			label5->Enabled = true;
			txServidor->Enabled = true;
			txBanco->Enabled = true;
			txUser->Enabled = true;
			txPass->Enabled = true;

			label6->Enabled = false;
			label18->Enabled = false;
			txbancoac->Enabled =false;
			txway->Enabled = false;
			//Verifica se o campo est vazio
			if ((txServidor->Text->ToString() == "")||(txBanco->Text->ToString()== "")){
				iniciarToolStripMenuItem->Enabled = false;
			}else{
				iniciarToolStripMenuItem->Enabled = true;
			}
		}

	}

	/********************************************************************************************************
	* Funo: txServidor																					*
	*********************************************************************************************************
	*																										*
	* Data de Criao: 18/08/2008																			*
	*																										*
	* Retorno: Void																							*
	*																										*	
	* Descrio: Responsvel pela habilitao do menu iniciar												*	
	*																										*
	*********************************************************************************************************/
	private: System::Void txServidor_TextChanged(System::Object^  sender, System::EventArgs^  e) {
		if ((txServidor->Text->ToString() == "") ||(txBanco->Text->ToString() == "")){
			iniciarToolStripMenuItem->Enabled = false;
		}else{
			iniciarToolStripMenuItem->Enabled = true;
		}
	}

	/********************************************************************************************************
	* Funo: txBanco																						*
	*********************************************************************************************************
	*																										*
	* Data de Criao: 18/08/2008																			*
	*																										*
	* Retorno: Void																							*
	*																										*	
	* Descrio: Responsvel pela habilitao do menu Iniciar												*	
	*																										*
	*********************************************************************************************************/
	private: System::Void txBanco_TextChanged(System::Object^  sender, System::EventArgs^  e) {
		 if ((txServidor->Text->ToString() == "") ||(txBanco->Text->ToString() == "")){
			iniciarToolStripMenuItem->Enabled = false;
		}else{
			iniciarToolStripMenuItem->Enabled = true;
		}
	}

	/********************************************************************************************************
	* Funo: bdAccess																						*
	*********************************************************************************************************
	*																										*
	* Data de Criao: 18/08/2008																			*
	*																										*
	* Retorno: Void																							*
	*																										*	
	* Descrio: Responsvel pela habilitao dos campos referente ao banco de dados 						*	
	*																										*
	*********************************************************************************************************/
	private: System::Void bdAccess_CheckedChanged(System::Object^  sender, System::EventArgs^  e) {
		if (bdAccess->Checked == true){
			label2->Enabled = false;
			label3->Enabled = false;
			label4->Enabled = false;
			label5->Enabled = false;
			txServidor->Enabled = false;
			txBanco->Enabled = false;
			txUser->Enabled = false;
			txPass->Enabled = false;

			label6->Enabled = true;
			label18->Enabled = true;
			txbancoac->Enabled = true;
			txway->Enabled = true;
			if ((txbancoac->Text->ToString() == "")||(txway->Text->ToString()=="")){
				iniciarToolStripMenuItem->Enabled = false;
			}else{
				iniciarToolStripMenuItem->Enabled = true;
			}
		
		}
	}

	/********************************************************************************************************
	* Funo: txbancoac																				*
	*********************************************************************************************************
	*																										*
	* Data de Criao: 18/08/2008																			*
	*																										*
	* Retorno: BYTE																							*
	*																										*	
	* Descrio: Responsvel pela habilitao do menu Iniciar												*	
	*																										*
	*********************************************************************************************************/
	private: System::Void txbancoac_TextChanged(System::Object^  sender, System::EventArgs^  e) {
		if ((txbancoac->Text->ToString() == "") ||(txway->Text->ToString() == "")){
			iniciarToolStripMenuItem->Enabled = false;
		}else{
			iniciarToolStripMenuItem->Enabled = true;
		}
	}

	/********************************************************************************************************
	* Funo: txWay																							*
	*********************************************************************************************************
	*																										*
	* Data de Criao: 18/08/2008																			*
	*																										*
	* Retorno: Void																							*
	*																										*	
	* Descrio: Responsvel pela habilitao do menu Iniciar												*	
	*																										*
	*********************************************************************************************************/
	private: System::Void txway_TextChanged(System::Object^  sender, System::EventArgs^  e) {
		if ((txbancoac->Text->ToString() == "") ||(txway->Text->ToString() == "")){
			iniciarToolStripMenuItem->Enabled = false;
		}else{
			iniciarToolStripMenuItem->Enabled = true;
		 }
	}

	/********************************************************************************************************
	* Funo: arrumaFinal																					*
	*********************************************************************************************************
	*																										*
	* Data de Criao: 20/08/2008																			*
	*																										*
	* Retorno: Void																							*
	*																										*	
	* Descrio: Responsvel pela configurao do que foi gravado para apresenta-lo no textbox				*	
	*																										*
	*********************************************************************************************************/
	private: Void arrumaFinal(char *str){
		if (str[0]==0) // verifica se ha uma linha vazia
			return;
		while ((str[strlen(str)-1]=='\n') || (str[strlen(str)-1]=='\r')){ // procura o terminador da string
			str[strlen(str)-1]=0;//  altera o terminador para 0
			if (str[0]==0) 
				return;
		}
	}

	/********************************************************************************************************
	* Funo: readFileString																				*
	*********************************************************************************************************
	*																										*
	* Data de Criao: 20/08/2008																			*
	*																										*
	* Retorno: Void																							*
	*																										*	
	* Descrio: Responsvel pela iniciao do programa e preenchimento do banco gravado					*	
	*																										*
	*********************************************************************************************************/
	private:Void readFileString(FILE *arquivo, char *destino, char *variavel, char *padrao){
		int achou = 0; // inicializa a variavel para informar que nao encontrou o texto
		char saux[255]; // recebe as linhas
		char *pstr; // ponteiro para o o =
		
		fseek(arquivo,0,SEEK_SET); //  coloca o cursor no inicio do arquivo
	
		// entra em um loop ate o final do arquivo ou ate encontrar a configuracao desejada
		while(!feof(arquivo)){
			fgets(saux,255,arquivo);
			arrumaFinal(saux);
			pstr = strchr(saux,'=');// 

			if (pstr != NULL)
				*pstr=0; //corta string no '='
			if (strncmp(variavel,saux,strlen(variavel))==0){ //verifica se ha a string procurada
				achou=1;
				break; // cancela o loop
			}
		}
		if (!(achou)){
			strcpy(destino,padrao); // caso nao encontre a string desejada coloca a padrao no lugar
			destino[strlen(padrao)] = 0;
		}else{
			strcpy(destino,pstr+1);  //pstr estava apontado para o '='
			destino[strlen(pstr+1)] = 0;
		}
	}

	/********************************************************************************************************
	* Funo: Form1_Load																					*
	*********************************************************************************************************
	*																										*
	* Data de Criao: 20/08/2008																			*
	*																										*
	* Retorno: Void																							*
	*																										*	
	* Descrio: Responsvel pela gravao das informaes solicitadas para abertura do banco				*	
	*																										*
	*********************************************************************************************************/
	private: System::Void btGravar_Click(System::Object^  sender, System::EventArgs^  e) {
		 StreamWriter ^txt = gcnew StreamWriter(L"saveBanco.txt");
		 //Grava os dados que se encontram nos textbox para o arquivo txt saveBanco.
		 txt->WriteLine("gravar =1");
		 txt->WriteLine("sqlServidor =" + txServidor->Text->ToString()->Trim());
		 txt->WriteLine("sqlBanco =" + txBanco->Text->ToString()->Trim());
		 txt->WriteLine("sqlUser =" + txUser->Text->ToString()->Trim());
		 txt->WriteLine("sqlPass =" + txPass->Text->ToString()->Trim());

		 txt->WriteLine("mdbBanco =" + txbancoac->Text->ToString()->Trim());
		 txt->WriteLine("mdbCaminho =" + txway->Text->ToString()->Trim());
		 
		 txt->Close();
	}
		 
	/*private: System::Void btRecebeEx_Click(System::Object^  sender, System::EventArgs^  e) {
		//Verifica se h algum terminal selecionado
		if (VConectados->SelectedIndex == -1){
			MessageBox::Show("Selecione um terminal.");
		}else{
		//Requisita configurao do terminal
			if (pfun_mt_reqexconfig(VConectados->SelectedIndex + 1) < 1){
				MessageBox::Show ("Erro enviando comando.");
			}
			else{
				timerEvento->Enabled = true;  
			}
		}
	}*/
};
}

