/****************************************************************************
* Aplicativo : SMTGeR... Servidor de Microterminais Gertec - Restaurante    *
* Autor		 : Ana Lcia S. Melo 										    *
* Referncia : SMTGeR - Programa Servidor para Micro Terminais              *
* Data       : 07/07/08													    *
* Ambiente   : Visual C++ 2005 (Express Edition)                            *
* Fonte      : pmtger.h														*
* Objetivo   : Declarao da DLL PMTG para microterminais Gertec MT720,		*
*			   MT740, GE750 e GE760.									   	*
* Notas		 : Este fonte destina-se exclusivamente como material de	    *
*			   auxilio a desenvolvedores de aplicaes para produtos Gertec.*
****************************************************************************/

#ifndef MTGER_H
#define MTGER_H

#include "structs.h"	//Estrurura para utilizao na DLL
#include <windows.h>



/****************************************************************************
*	 Declarao dos ponteiros das Funes									*
*	(que acessaro as funes da dll dinamicamente)							*
*****************************************************************************/
	
	int (_stdcall *pfun_mt_startserver)		( HANDLE hWindow, int conecmsg, int commumsg );
	void(_stdcall *pfun_mt_finishserver)	( void );	
	TTABSOCK(_stdcall *pfun_mt_connectlist)	( void ); 
	int (_stdcall *pfun_mt_dispch)			( int ID, char ch );
	int (_stdcall *pfun_mt_dispstr)			( int ID, char *str);
	int (_stdcall *pfun_mt_getkey)			( int ID, char *buf );
	int (_stdcall *pfun_mt_formfeed)		( int ID );
	int (_stdcall *pfun_mt_linefeed)		( int ID );
	int (_stdcall *pfun_mt_carret)			( int ID );
	int (_stdcall *pfun_mt_gotoxy)			( int ID, int lin, int col );
	int (_stdcall *pfun_mt_setenablekey)	( int ID, BOOL value );
	int (_stdcall *pfun_mt_getenablekey)	( int ID );
	char* (_stdcall *pfun_mt_inet_ntoa_inv)	( DWORD oip );
	int (_stdcall *pfun_mt_reqconfigserial)	( int ID, BYTE COM );
	int (_stdcall *pfun_mt_sendconfigserial)( int ID, ARG_COM_SETUPSERIAL *config );
	int (_stdcall *pfun_mt_getconfigserial) ( int ID, ARG_COM_SETUPSERIAL *config );
	int (_stdcall *pfun_mt_restart)			( int ID );
	int (_stdcall *pfun_mt_setenableserial)	(int ID, BYTE COM, int OnOff);
	int (_stdcall *pfun_mt_sendbinserial)	(int ID, BYTE COM, LPBYTE Bin, BYTE tam);
	int (_stdcall *pfun_mt_getserial)		(int ID, int *sercom, char *buf);
	int (_stdcall *pfun_mt_getexconfig)		(int ID, TExSetupTCP* config);
	int (_stdcall *pfun_mt_reqexconfig)		(int ID);

/****************************************************************************/




#endif