VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cls_ComandosBanco"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'*************************************************************************
' Projeto   :          CLASSE PARA MANIPULAO DE DADOS NO BANCO PARA OS MICROTERMINAIS
' Arquivo   :          cls_ComandosBanco
' Data Criao :       24/01/2008
' Verso :             0.0.0.1
' Reviso :
' Data   :             24/01/2008
' Modificaes :
'*************************************************************************
Dim Conexao As New ADODB.Connection
Dim StringConexao As String

'********************************************************************************************************
'                               ***** Conectar() *****
'********************************************************************************************************
' Data de Criao:
' Autor:
' Entrada: void
' Sada: Conexao com o Banco de Dados
' Descrio: Cria a conexo com o Banco
'********************************************************************************************************
Public Sub Conectar()
   
    Dim Servidor As String
    Dim Banco As String
    Dim UId As String
    Dim Pwd As String
    Dim teste As Boolean
    Dim strArquivo As String
    Dim strLocal As String

On Error GoTo erro
   
   'Esta rotina localiza o banco em access caso este esteja ativo
   If FrmPrincipal.CkAccess.Value = 1 Then
      strArquivo = FrmPrincipal.Text7.Text
      strLocal = App.Path
     
      StringConexao = "Driver={Microsoft Access Driver (*.mdb)};" & _
                    "Dbq=" & strArquivo & ";" & _
                    "DefaultDir=" & strLocal & ";" & _
                    "Uid=Admin;Pwd=;"
   
   'Caso o banco SQL esteja ativo efetua esta rotina
   ElseIf FrmPrincipal.CkSql.Value = 1 Then
      Servidor = FrmPrincipal.Text1
      Banco = FrmPrincipal.Text2
      UId = FrmPrincipal.Text3
      Pwd = FrmPrincipal.Text4
   'TI_Eliseu\SQLExpress
   'azfood_Data_Br3
      If (UId = "") Or (Pwd = "") Then
         StringConexao = "Provider=SQLOLEDB; Data Source= " & Servidor & "; Initial Catalog=" & Banco & ";Integrated Security=SSPI;"
      Else: StringConexao = "Provider=SQLOLEDB;Data Source=" & Servidor & ";Initial Catalog=" & Banco & ";User Id= " & UId & "; Password= " & Pwd & ";"
      End If
   End If
    Conexao.Open (StringConexao)
    conec = True
    
    Exit Sub
erro: conec = False 'MsgBox "Dados SQL Invlidos!"


End Sub

'********************************************************************************************************
'                               ***** Fechar() *****
'********************************************************************************************************
' Data de Criao: 24/01/2008
' Autor: Mario Henrique Adaniya
' Entrada: void
' Sada: void
' Descrio: Fecha a conexo do Banco de Dados
'********************************************************************************************************
Public Sub Fechar()

    Conexao.Close

End Sub

Public Sub Comando(ByRef pComando As String)
  Dim iComando As New ADODB.Command
  iComando.ActiveConnection = Conexao
  iComando.CommandText = pComando
  iComando.CommandType = adCmdText
  iComando.Execute
End Sub

Public Function ComandoRetorno(ByRef pComando As String) As ADODB.Recordset
    On Error GoTo ErrorHandler
  Dim iRecordSet As New ADODB.Recordset

  iRecordSet.ActiveConnection = Conexao
  iRecordSet.Source = pComando
  iRecordSet.CursorType = adOpenStatic
  iRecordSet.Open
  Set ComandoRetorno = iRecordSet
  
  Exit Function
ErrorHandler:
  
End Function

