VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cls_Negocio"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'*************************************************************************
' Projeto   :          CLASSE DE NEGCIOS ENTRE A APLICAO E O BANCO
' Arquivo   :          cls_Negocio
' Data Criao :       24/01/2008
' Verso :             0.0.0.1
' Reviso :
' Data   :             24/01/2008
' Modificaes :
'*************************************************************************
Public Header As Integer
Public Cartao As Integer
Public DataHora As Date
Public TipoMovimento As String
Public TaxaServico As Double
Public NumeroPessoas As Integer
Public Operador As Integer


Public Produto As Integer
Public Qtd As Double
Public Origem As String
Public ProdDescricao As String
Public Tipo As String
Public PrecoUnit As Double
Public Total As Double
Public Cliente As Integer
Public Mesa As Integer
Public Usuario As Integer
Public Guia As Integer
Public iLocal As Integer
Public Fracao As String
Public FraSeq As Integer
Public Cancelado As String
Public ValorServico As Double
Public Observacao As String
Public Impressao1 As String
Public ImpPocket As String


'********************************************************************************************************
'                               ***** BuscaUsuario() *****
'********************************************************************************************************
' Data de Criao:
' Autor:
' Entrada: Cdigo do usuario
' Sada: Indice dos usuarios com aquele cdigo
' Descrio: Busca no Banco o usuario pelo cdigo
'********************************************************************************************************
Public Function BuscaUsuario(ByVal IDUsuario As Integer) As ADODB.Recordset
    Dim iBanco As New cls_ComandosBanco
    
    iBanco.Conectar
    Set BuscaUsuario = iBanco.ComandoRetorno("SELECT usuId,usuNome,funID,usuLogin FROM tabUsuario WHERE usuID = " & IDUsuario & "")
    
End Function
'********************************************************************************************************
'                               ***** BuscaEntregador() *****
'********************************************************************************************************
' Data de Criao:
' Autor:
' Entrada: Cdigo do usuario
' Sada: Indice dos usuarios com aquele cdigo
' Descrio: Busca no Banco o usuario pelo cdigo
'********************************************************************************************************
Public Function BuscaEntregador(ByVal IDUsuario As Integer) As ADODB.Recordset
    Dim iBanco As New cls_ComandosBanco
    
    iBanco.Conectar
    Set BuscaEntregador = iBanco.ComandoRetorno("SELECT usuId,usuNome,funID,usuLogin FROM tabUsuario WHERE usuID = " & IDUsuario & "")
    
End Function
'********************************************************************************************************
'                               ***** VerificaDisponibilidadeCartao() *****
'********************************************************************************************************
' Data de Criao:
' Autor:
' Entrada: Cdigo do carto
' Sada: Indice de cartes com cdigo dado pela entrada
' Descrio: Busca no banco os cartes pelo cdigo
'********************************************************************************************************
Public Function VerificaDisponibilidadeCartao(ByVal Cartao As Integer) As ADODB.Recordset
    Dim iBanco As New cls_ComandosBanco
    
    iBanco.Conectar
    Set VerificaDisponibilidadeCartao = iBanco.ComandoRetorno("SELECT carId,carStatus, carIngresso, carConsumacao, carDesconto, carTxServico FROM tabCartao WHERE (carStatus = 'D' or carStatus = 'U') " & _
                                                         " and carId = " & Cartao & "")
                                                         
End Function

'********************************************************************************************************
'                               ***** BuscaGuia() *****
'********************************************************************************************************
' Data de Criao:
' Autor:
' Entrada: Cdigo da Guia
' Sada: Indice de guias com cdigo dado pela entrada
' Descrio: Busca no banco as guias pelo cdigo
'********************************************************************************************************
Public Function BuscaGuia(ByVal Guia As Integer) As ADODB.Recordset
    Dim iBanco As New cls_ComandosBanco
    
    iBanco.Conectar
    Set BuscaGuia = iBanco.ComandoRetorno("SELECT usuId,usuNome FROM TabUsuario WHERE usuId = " & Guia & " AND funId = 4")
    
End Function


'********************************************************************************************************
'                               ***** BuscaProduto() *****
'********************************************************************************************************
' Data de Criao:
' Autor:
' Entrada: Cdigo do carto
' Sada: Indice de cartes com cdigo dado pela entrada
' Descrio: Busca no banco os cartes pelo cdigo
'********************************************************************************************************
Public Function BuscaProduto(ByVal Produto As Double) As ADODB.Recordset
    Dim iBanco As New cls_ComandosBanco
    
    iBanco.Conectar
    Set BuscaProduto = iBanco.ComandoRetorno("SELECT proId,proDescricao,proPreco FROM tabProduto WHERE proId = " & Produto & "")
    
End Function

'********************************************************************************************************
'                               ***** BuscaHeaderCartao() *****
'********************************************************************************************************
' Data de Criao: 01/02/2008
' Autor: Mario Henrique Adaniya
' Entrada:
' Sada:
' Descrio:
'********************************************************************************************************
Public Function BuscaHeaderCartao(ByVal Cartao As Integer) As ADODB.Recordset
    Dim iBanco As New cls_ComandosBanco
    iBanco.Conectar
    Set BuscaHeaderCartao = iBanco.ComandoRetorno("select mheId from TabHeaderMovimento where carId = " & Cartao & " And mheStatus = '1'")
End Function
'********************************************************************************************************
'                               ***** BuscaHeaderDelivery() *****
'********************************************************************************************************
' Data de Criao: 01/02/2008
' Autor: Mario Henrique Adaniya
' Entrada:
' Sada:
' Descrio:
'********************************************************************************************************
Public Function BuscaHeaderDelivery(ByVal pedidoDelivery As Integer) As ADODB.Recordset
    Dim iBanco As New cls_ComandosBanco
    iBanco.Conectar
    Set BuscaHeaderDelivery = iBanco.ComandoRetorno("SELECT mheId, mheExpedido FROM TabHeaderMovimento WHERE devId = " & pedidoDelivery & " ")
End Function

'********************************************************************************************************
'                               ***** BuscaObs() *****
'********************************************************************************************************
' Data de Criao: 01/02/2008
' Autor: Mario Henrique Adaniya
' Entrada: Cdigo da observao
' Sada:
' Descrio: Busca a observao
'********************************************************************************************************
Public Function BuscaObs(ByVal Obs As Integer) As ADODB.Recordset
    Dim iBanco As New cls_ComandosBanco
    
    iBanco.Conectar
    Set BuscaObs = iBanco.ComandoRetorno("SELECT * FROM tabObs WHERE obsId = " & Obs)
    
End Function

'********************************************************************************************************
'                               ***** InsereHeader() *****
'********************************************************************************************************
' Data de Criao: 03/03/2008
' Autor: Mario Henrique Adaniya
' Entrada:
' Sada:
' Descrio: Insere na TabHeaderMovimento, um novo movimento.
'********************************************************************************************************
Public Sub InsereHeader()
    Dim iBanco As New cls_ComandosBanco
    iBanco.Conectar
    iBanco.Comando (" INSERT INTO TabHeaderMovimento " & _
                    " (carID, mheDataHora,mheTipoMov,mheStatus,mheTaxaServico,mheNumeroPessoa,mheOperador,mesId,mheDescFecha,mheDescRec,mheTroco)  " & _
                    " VALUES ( " & Cartao & ",'" & DataHora & "','" & TipoMovimento & "',1,'" & TaxaServico & "'," & NumeroPessoas & "," & Operador & ",0,0,0,0)")
End Sub

'********************************************************************************************************
'                               ***** ExpedirPedido() *****
'********************************************************************************************************
' Data de Criao: 03/03/2008
' Autor: Mario Henrique Adaniya
' Entrada: Cdigo da entrega
' Sada:
' Descrio: Muda o status do pedido de Aberto, para Expedido.
'********************************************************************************************************
Public Function ExpedirPedido(ByRef codDeliveryId As Integer, ByVal codEntregador As Integer)
    Dim iBanco As New cls_ComandosBanco
    
    DataHora = Now
    iBanco.Conectar
    iBanco.Comando ("UPDATE tabHeaderMovimento SET mheExpedido = '0', mheEntregador = '" & codEntregador & "',mheDataHoraExpedido = '" & DataHora & "' " & _
                    "WHERE devID = '" & codDeliveryId & "' AND mheStatus = '1'")
                
End Function

'********************************************************************************************************
'                               ***** InsereMovimento() *****
'********************************************************************************************************
' Data de Criao: 01/02/2008
' Autor: Mario Henrique Adaniya
' Entrada:
' Sada:
' Descrio:
'********************************************************************************************************
Public Sub InsereMovimento()
    Dim iBanco As New cls_ComandosBanco
    iBanco.Conectar
    iBanco.Comando ("INSERT INTO tabMovimento ( movTipo,movDataHora," & _
                    "movProdDescricao,movQtde,movPrecoUnit, movPrecoTotal, movTaxaServico,cliID," & _
                    "carID, mesID,usuID,proID,movOBS,usuOP,movFracao,movFraSeq,mheID,movCancelado,movValorServico,movImpressao1,movImpPocket, movOrigem, movLocal, guiId, movValorComissaoGuia ) " & _
                    " VALUES ( '" & Tipo & "','" & DataHora & "','" & _
                    Replace(Trim(ProdDescricao), "'", ".") & "'," & Replace(Qtd, ",", ".") & "," & Replace(PrecoUnit, ",", ".") & "," & Replace(Total, ",", ".") & "," & TaxaServico & "," & Cliente & "," & Cartao & "," & Mesa & "," & Usuario & "," & Produto & ",'" & Observacao & "'," & _
                    Usuario & ",'" & Fracao & "'," & FraSeq & "," & Header & ",'" & Cancelado & "'," & ValorServico & ",'" & Impressao1 & "','" & ImpPocket & "','" & Origem & "'," & iLocal & "," & Guia & "," & 0 & ")")
End Sub

'********************************************************************************************************
'                               ***** FechaCartao() *****
'********************************************************************************************************
' Data de Criao: 01/02/2008
' Autor: Mario Henrique Adaniya
' Entrada: cdigo do carto
' Sada:
' Descrio: Muda o status do carto para realizar o fechamento.
'********************************************************************************************************
Public Function FechaCartao(ByVal pCartao As Integer, ByVal pLocal As Integer) As Boolean
    Dim iBanco As New cls_ComandosBanco
    iBanco.Conectar
    iBanco.Comando (" UPDATE tabHeaderMovimento SET mheLocal = " & pLocal & ", mheImpFech = 'N' WHERE " & _
                    "carId = " & Cartao & " AND mheStatus = '1'")
    FechaCartao = True
End Function

'********************************************************************************************************
'                               ***** MudaStatusCartao() *****
'********************************************************************************************************
' Data de Criao: 01/02/2008
' Autor: Mario Henrique Adaniya
' Entrada: Cdigo do Carto e o novo status
' Sada: Boolean
' Descrio: Muda o status do carto para o novo status
'********************************************************************************************************
Public Function MudaStatusCartao(ByVal codCartao As Integer, ByVal StatusCartao As String) As Boolean
    Dim iBanco As New cls_ComandosBanco
    
    iBanco.Conectar
    iBanco.Comando ("UPDATE tabCartao SET carStatus = '" & StatusCartao & "' WHERE  carID = " & codCartao & "")
    MudaStatusCartao = True
    
End Function

'********************************************************************************************************
'                               ***** VerificaCartaoParaFechamento() *****
'********************************************************************************************************
' Data de Criao: 01/02/2008
' Autor: Mario Henrique Adaniya
' Entrada: Cdigo do Carto
' Sada:
' Descrio: Verifica se o carto esta sendo utilizado para fechamento.
'********************************************************************************************************
Public Function VerificaCartaoParaFechamento(ByVal Cartao As Integer) As ADODB.Recordset
    Dim iBanco As New cls_ComandosBanco
    
    iBanco.Conectar
    Set VerificaCartaoParaFechamento = iBanco.ComandoRetorno("SELECT carId,carStatus FROM tabCartao WHERE carStatus = 'U' " & _
                                                         " AND carId = " & Cartao & "")
                                                         
End Function

'********************************************************************************************************
'                               ***** CarregaConfiguracao() *****
'********************************************************************************************************
' Data de Criao: 01/02/2008
' Autor: Mario Henrique Adaniya
' Entrada:
' Sada:
' Descrio: Carrega as configuraes gerais
'********************************************************************************************************
Public Function CarregaConfiguracao() As ADODB.Recordset
    Dim iBanco As New cls_ComandosBanco
    iBanco.Conectar
    Set CarregaConfiguracao = iBanco.ComandoRetorno("SELECT * FROM tabConfiguracaoGeral")
End Function

'********************************************************************************************************
'                               ***** ConsultaProduto() *****
'********************************************************************************************************
' Data de Criao: 01/02/2008
' Autor: Mario Henrique Adaniya
' Entrada: Cdigo do Carto
' Sada:
' Descrio: Consulta os produtos que foram consumidos pelo carto.
'********************************************************************************************************
Public Function ConsultaProduto(ByVal codCartao As Integer) As ADODB.Recordset
    Dim iBanco As New cls_ComandosBanco
    iBanco.Conectar
    
    Set ConsultaProduto = iBanco.ComandoRetorno("SELECT movID, mheID, carID, movDataHora, proID, movProdDescricao, movQtde, movPrecoUnit, movPrecoTotal" & _
                                                " FROM tabMovimento " & _
                                                "WHERE movCancelado = 'N' AND  carID = " & codCartao & " ")
End Function


'********************************************************************************************************
'                               ***** UpdateHeader() *****
'********************************************************************************************************
' Data de Criao: 05/02/2008
' Autor: Mario Henrique Adaniya
' Entrada:
' Sada:
' Descrio: Alterao por causa do radio, para isto a tabHeaderMovimento recebe alguns parametros para
'            funcionar.
'********************************************************************************************************
Public Function UpdateHeader(ByVal pCartao As Integer, ByVal imprimirPocket As String) As Boolean
    Dim iBanco As New cls_ComandosBanco
    iBanco.Conectar
    iBanco.Comando (" UPDATE tabHeaderMovimento SET mheImprimirPocket = '" & imprimirPocket & "' WHERE " & _
                    "carId = " & Cartao & " ")
    UpdateHeader = True
End Function

