Attribute VB_Name = "gertec"
'SERVIDOR COM SUPORTE AOS MICROTERMINAIS: GE 750, GE 760, MT 740, MT720

'DECLARAO DE TIPOS, COMPONENTES, PROCEDURES E FUNES GERAIS


'*************************************************************************
' Projeto   :          Declarao de Funes pmtg - VB
' Arquivo   :          gertec
' Data Criao :       23/01/2008
' Verso :             0.0.0.0.1
' Reviso :
' Data   :             23/01/2008
' Modificaes :

'*************************************************************************
'*************************************************************************
' Funes e Procedimentos Utilizadas pelo Sistema

'  mt_startserver      Funo Inicial para os terminais conectarem ao servidor
'  mt_finishserver     DLL liberada da memria e desconexo dos terminais
'  mt_dispstr          Envio de Texto para o diaplay do terminal
'  mt_linefeed         Incrementa uma nova linha no display
'  mt_connectlist      Lista terminais conectados

'  inet_ntoa            Funo para transformar ID de rede em endereo IP
'  lstrlen              Funo auxiliar para transformar string em ponteiro
'  lstrcpy              Funo auxiliar para transformar string em ponteiro
'*************************************************************************

'*--------------------------------------------------------------------*/
'*                +++>>> Variaveis  <<<+++              */
'*--------------------------------------------------------------------*/
Global v_Hwnd As Long
 
 Public auxIP As String
 Public conec As Boolean

Public peso As Boolean
Public TermMenu As Integer


'*--------------------------------------------------------------------*/
'*                +++>>> Tipos <<<+++              */
'*--------------------------------------------------------------------*/

'tipo de varivel utilizado pela funo GetTabConectados.
Public Type TTABSOCK
    TabSock(0 To 255) As Long

End Type
        

'*--------------------------------------------------------------------*/
'*                +++>>> Declaraes de Funo e Procedimentos <<<+++              */
'*--------------------------------------------------------------------*/

'INICIALIZA

'Declarao de Funes para o Tratamento de Valores IP
Declare Function inet_ntoa Lib "ws2_32.dll" (ByVal inn As Long) As Long
'FIXIT: As Any is not supported in Visual Basic .NET. Use a specific type.                 FixIT90210ae-R5608-H1984
Declare Function lstrlen Lib "kernel32" Alias "lstrlenA" (ByVal lpString As Any) As Long
Declare Function lstrcpy Lib "kernel32" Alias "lstrcpyA" (ByVal lpString1 As String, ByVal lpString2 As Long) As Long
    
'Inicia o Servidor dos Microterminais. Deve ser chamada no incio do aplicativo e antes de qualquer outra funo da DLL. O Handle  o manipulador da janela do aplicativo que responde as mensagens dos microterminais. Havendo sucesso, esta rotina retorna TRUE.
Declare Function mt_startserver Lib "pmtg.dll" (ByRef mywhnd As Long, ByVal conecmsg As Integer, ByVal commumsg As Integer) As Long

'Finaliza a Execuo da DLL
Declare Sub mt_finishserver Lib "pmtg.dll" ()

'Retorna a lista de terminais conectados
Declare Function mt_connectlist Lib "pmtg.dll" () As TTABSOCK

'Faz com que o terminal se reinicialize (IDRestart).
Declare Function mt_restart Lib "pmtg.dll" (ByVal id As Long) As Long

'Esta rotina verifica na lista interna de eventos se h envio de string editvel.
'Declare Function mt_reqeditstring Lib "pmtg.dll" (ByVal id As Long)

'--------------------------------------------------------------------------------------------------------------
'
'---------------------------------------------------------------------------------------------------------------
'DISPLAY

'Funo para envio de caracter ao Display
'Declare Function mt_dispstr Lib "pmtg.dll" (ByVal id As Long, ByRef str As Byte) As Long
Declare Function mt_dispstr Lib "pmtg.dll" (ByVal id As Long, ByVal str As String) As Long

Declare Function mt_dispch Lib "pmtg.dll" (ByVal id As Long, ByVal str As Byte) As Long

'Funo para pular linha
Declare Function mt_linefeed Lib "pmtg.dll" (ByVal id As Long) As Long

'Envia o comando de FormFeed(Apagar tela) para o terminal.
Declare Function mt_formfeed Lib "pmtg.dll" (ByVal id As Long) As Long

'Envia o comando de CarriageReturn para o terminal (IDvCarRet).
Declare Function mt_carret Lib "pmtg.dll" (ByVal id As Long) As Long

'Envia o comando de BackSpace para o terminal (IDvBackSpace).
Declare Function mt_backspace Lib "pmtg.dll" (ByVal id As Long) As Long

'Esta rotina coloca ou no o microterminal em modo de edio de string. A string  passada pela
'varivel String, o estado de edio  passado pela varivel boleana OnOff. Se PassWord for TRUE, o caracteres so
'substitudos no display por asteriscos (*).
'Declare Function mt_seteditstring Lib "pmtg.dll" (ByVal id As Long, ByVal str As String, ByVal OnOff As Long, ByVal PassWord As Long) As Long

'Esta rotina verifica na lista interna de eventos se h envio de string editvel.
'Requisita o estado do EditString do terminal (IDbGetEditString). A DLL enviar uma mensagem com a resposta deste comando.
'Retorna: 0 houve erro, outro valor se comando realizado com sucesso.
'Declare Function mt_reqeditstring Lib "pmtg.dll" (ByVal id As Long) As Long

'Esta rotina retorna TRUE se o microterminal identificado pelo ID est em modo de edio de string.
'Declare Function mt_geteditstring Lib "pmtg.dll" (ByVal id As Long) As Long
'Declare Function mt_geteditstring Lib "pmtg.dll" (ByVal id As Long, ByRef buf As Byte) As Long

'Esta rotina posiciona o cursor do display na linha lin e coluna Col do microternimal.
Declare Sub mt_gotoxy Lib "pmtg.dll" (ByVal id As Long, ByVal lin As Integer, ByVal col As Integer)

'Esta rotina posiciona o cursor do display na linha Lin+DeltaLin e coluna Col+DeltaCol do microternimal identificado pelo ID.
'Declare Sub mt_gotoxyref Lib "pmtg.dll" (ByVal id As Long, ByVal L As Integer, ByVal c As Integer)


'--------------------------------------------------------------------------------------------------------------
'TECLADO

'Esta rotina habilita ou no o teclado do microterminal atravs da opo OnOff para o microternimal.
Declare Function mt_setenablekey Lib "pmtg.dll" (ByVal id As Long, ByVal OnOff As Long) As Long

'Esta rotina retorna o estado do teclado do microternimal.
Declare Function mt_getenablekey Lib "pmtg.dll" (ByVal id As Long) As Long

'Envia o comando de SetCapsLock para o terminal (IDvSetCapsLock).
'OnOff: ativa (1) e desativa (0) o CapsLock.
'retorna: 0 houve erro, outro valor se comando realizado com sucesso.
'Declare Sub mt_setcapslock Lib "pmtg.dll" (ByVal id As Long, ByVal OnOff As Long)

'Envia o comando de SetNumLock (teclado numerico) para o terminal.
'OnOff: ativa (1) e desativa (0) o NumLock.
'retorna: 0 houve erro, outro valor se comando realizado com sucesso.
'Declare Sub mt_setnumlock Lib "pmtg.dll " (ByVal id As Long, ByVal OnOff As Long)

'Requisita o estado do CapsLock do terminal (IDbGetCapsLock). A DLL enviar uma mensagem com a resposta deste comando.
'retorna: 0 houve erro, outro valor se comando realizado com sucesso.
'Declare Function mt_getcapslock Lib "pmtg.dll" (ByVal id As Long) As Long

'Requisita o estado do NumLock do terminal (IDbGetNumLock). A DLL enviar uma mensagem com a resposta deste comando.
'retorna: 0 houve erro, outro valor se comando realizado com sucesso.
'Declare Function mt_getnumlock Lib "pmtg.dll" (ByVal id As Long) As Long

'Envia o comando de SetBeepkey para o terminal (IDvSetBeepKey).
'Declare Sub mt_setbeepkey Lib "pmtg.dll" (ByVal id As Long, ByVal OnOff As Long)

'Envia o comando de SetBeep (dispara beep) para o terminal (IDvSetBeep).
'Declare Sub mt_setbeep Lib "pmtg.dll" (ByVal id As Long, ByVal OnOff As Long)

'Recebe uma tecla do terminal (IDcGetCharTerm). buf: tecla recebida.
'retorna: 0 houve erro, outro valor se comando realizado com sucesso.
Declare Function mt_getkey Lib "pmtg.dll" (ByVal id As Long, ByRef buf As Byte) As Long

'---------------------------------------------------------------------------------------------------------------

'SERIAL

'int __stdcall mt_setenableserial(int ID, const BYTE COM, const BOOL OnOff);
'Declare Function mt_setenableserial Lib "pmtg.dll" (ByVal ID As Long, COM As Byte, ByVal ONOFF As Boolean) As Long
Declare Function mt_setenableserial Lib "pmtg.dll" (ByVal id As Long, ByVal com As Long, ByVal OnOff As Long) As Long

'int __stdcall mt_getenableserial(int ID, const BYTE COM);
Declare Function mt_getenableserial Lib "pmtg.dll" (ByVal id As Long, com As Byte) As Long

'int __stdcall mt_sendbinserial(int ID, const BYTE COM, LPBYTE Bin, BYTE tam);
Declare Function mt_sendbinserial Lib "pmtg.dll" (ByVal id As Long, ByVal com As Byte, ByRef Bin As Byte, ByVal Tam As Byte) As Long

'int __stdcall mt_getserial(int ID, int *sercom, char *buf);
Declare Function mt_getserial Lib "pmtg.dll" (ByVal id As Long, ByRef sercom As Long, ByRef buf As Byte) As Long

'int __stdcall mt_sendconfigserial(int ID, ARG_COM_SETUPSERIAL *config);
Declare Function mt_sendconfigserial Lib "pmtg.dll" (ByVal id As Long, ByRef CNF As ARG_COM_SETUPSERIAL) As Long

'int __stdcall mt_reqconfigserial(int ID, BYTE COM);
Declare Function mt_reqconfigserial Lib "pmtg.dll" (ByVal id As Long, ByVal com As Byte) As Long

'int __stdcall mt_getconfigserial(int ID, ARG_COM_SETUPSERIAL *config);
Declare Function mt_getconfigserial Lib "pmtg.dll" (ByVal id As Long, ByRef CNF As ARG_COM_SETUPSERIAL) As Long

'Declare Function mt_settermserial Lib "pmtg.dll" (ByVal id As Long, ByVal com As Byte, ByVal term As Byte, ByVal OnOff As Long) As Long


'typedef struct {
'unsigned long baud; // baudrate: 300 a 115.200
'unsigned short bits; // data bits
'unsigned short parity; // paridade
'unsigned short stops; // stop bits
'unsigned char handshaking; // 0 = sem handshaking, 1 = RTS/CTS
'} TSetupSerial;

Public Type TSetupSerial
    baud(0 To 3) As Byte 'Baud Rate: 300 a 115.200
    bits(0 To 1) As Byte 'Data Bits
    parity(0 To 1) As Byte 'Paridade
    stops(0 To 1) As Byte 'Stop Bits
    handshaking As Byte '0 = Sem Hand Shaking, 1 = RTS/CTS
End Type


'typedef struct {
'unsigned char Com;
'TSetupSerial Setup;
'}ARG_COM_SETUPSERIAL;

Public Type ARG_COM_SETUPSERIAL
    com As Byte
    STP As TSetupSerial
End Type

Public Type TSetupTCP
    microT_IP As Long  ' Endereo IP do terminal
    server_IP As Long  'Endereo IP do servidor
    msknet_IP As Long  'Mscara de rede
    bDHCP As Long ' 1 = IP dinmico, 0 = IP fixo.
End Type

Public conf As TSetupTCP



'declaracoes paracomunicacao serial
'    Public Type TSetupSerial
'        baud As Long 'unsigned long ; // baudrate: 300 a 115.200
'        bits As Long 'unsigned short; // data bits
'        parity As Long 'unsigned short; // paridade
'        stops As Long 'unsigned short ; // stop bits
'        handshaking As Long 'unsigned char ; // 0 = sem handshaking, 1 = RTS/CTS
'        '} TSetupSerial;
'    End Type
'
'    Public Type ARG_COM_SETUPSERIAL
'        COM As Long 'unsigned char ;
'        Setup As TSetupSerial
'    End Type
    
    
'Declare Function mt_setenableserial Lib "pmtg.dll" (ByVal ID As Long, ByVal COM As Long, ByVal ONOFF As Long) As Long
'Declare Function mt_sendconfigserial Lib "pmtg.dll" (ByVal ID As Long, ByRef Conf As ARG_COM_SETUPSERIAL) As Long
'Declare Function mt_sendbinserial Lib "pmtg.dll" (ByVal ID As Long, ByVal COM As Long, BIN As String, ByVal TAM As Long) As Long
'Declare Function mt_getserial Lib "pmtg.dll" (ByVal ID As Long, ByVal SERCOM As Long, ByVal caReadBuf As String) As Long
'Declare Function mt_reqconfigserial Lib "pmtg.dll" (ByVal ID As Long, ByVal COM As Long) As Long


'(int ID, int *sercom, char *buf);


Public Function StringFromPointer(ByVal lPointer As Long) As String
    '
    Dim strTemp As String
    Dim lRetVal As Long
    '
    'prepare the strTemp buffer
    strTemp = String$(lstrlen(ByVal lPointer), 0)
    '
    'copy the string into the strTemp buffer
    lRetVal = lstrcpy(ByVal strTemp, ByVal lPointer)
    '
    'return a string
    If lRetVal Then StringFromPointer = strTemp
    '
End Function


'********************************************************************************************************
' Funo: enviaIP
'********************************************************************************************************
'
' Descrio: Recebe o IP do terminal em formato string e transforma para formato de rede
'
'********************************************************************************************************

Function enviaIP(campo As String, b() As Byte)
Dim i As Integer
Dim controle As Integer
Dim posicao As Integer
Dim carac As String '

Dim buffer As Byte
Dim buf(0 To 3) As Byte

        i = 0
        'Varivel que verificar se o byte est preparado para ser modificado na estrutura
        controle = 0
        'Posio do byte
        posicao = 3
    
        tamanho = Len(campo)
        
        While i <= tamanho
            'A varivel carac recebe um byte em formato de rede
            If Mid(campo, (i + 1), 1) <> "." And Mid(campo, (i + 1), 1) <> "" Then
                buffer = Asc(Mid(campo, (i + 1), 1))
                carac = carac & "" & Chr(buffer)
            Else
                controle = 1
            End If
            'Quando pronto, este byte  modificado na estrutura
            If controle = 1 Then
                b(posicao) = CByte(carac)
                posicao = posicao - 1
                controle = 0
                carac = ""
            End If
            i = i + 1
        Wend

End Function

'********************************************************************************************************
' Funo: HexToDec
'********************************************************************************************************
'
' Descrio: Converte os nmeros de hexadecimal para decimal
'
'********************************************************************************************************

Function HexToDec(HexValue As String) As Long
    HexToDec = Val("&h" & HexValue)
End Function

'********************************************************************************************************
' Funo: compara
'********************************************************************************************************
'
' Descrio: Verifica se o usurio digitou valores vlidos ('0' at '9' e de 'A' at 'F')
'
'********************************************************************************************************

Function compara(buf As String) As Byte
    If buf = "0" Or buf = "1" Or buf = "2" Or buf = "3" Or buf = "4" Or buf = "5" Or buf = "6" Or buf = "7" Or buf = "8" Or buf = "9" Or buf = "a" Or buf = "b" Or buf = "c" Or buf = "d" Or buf = "e" Or buf = "f" Or buf = "A" Or buf = "B" Or buf = "C" Or buf = "D" Or buf = "E" Or buf = "F" Then
       compara = 1
    Else
       compara = 0
    End If
End Function

'********************************************************************************************************
' Funo: converte
'********************************************************************************************************
'
' Descrio: Converte os nmeros de decimal para hexadecimal
'
'********************************************************************************************************

Function converte(str As String) As Byte
Dim str1 As String
Dim str1a As Integer
Dim str2 As String
Dim str2a As Integer
Dim soma As Integer
    
    str1 = (Mid(str, 1, 1))
    str2 = (Mid(str, 2, 1))
    
    str1a = 0
    str2a = 0
   
   Select Case str1
      Case (0): str1a = 0
      Case (1): str1a = 16
      Case (2): str1a = 32
      Case (3): str1a = 48
      Case (4): str1a = 64
      Case (5): str1a = 80
      Case (6): str1a = 96
      Case (7): str1a = 112
      Case (8): str1a = 128
      Case (9): str1a = 144
      Case ("a"): str1a = 160
      Case ("b"): str1a = 176
      Case ("c"): str1a = 192
      Case ("d"): str1a = 208
      Case ("e"): str1a = 224
      Case ("f"): str1a = 240
   End Select
   
    Select Case str2
      Case (0): str2a = 0
      Case (1): str2a = 1
      Case (2): str2a = 2
      Case (3): str2a = 3
      Case (4): str2a = 4
      Case (5): str2a = 5
      Case (6): str2a = 6
      Case (7): str2a = 7
      Case (8): str2a = 8
      Case (9): str2a = 9
      Case ("a"): str2a = 10
      Case ("A"): str2a = 10
      Case ("b"): str2a = 11
      Case ("B"): str2a = 11
      Case ("c"): str2a = 12
      Case ("C"): str2a = 12
      Case ("d"): str2a = 13
      Case ("D"): str2a = 13
      Case ("e"): str2a = 14
      Case ("E"): str2a = 14
      Case ("f"): str2a = 15
      Case ("F"): str2a = 15
   End Select
   
   soma = str1a + str2a
      
   converte = soma

End Function

